searchData={"content_type":"text/markdown","items":[{"doc":"API calls for all endpoints tagged `Container`.","ref":"DockerEngineAPI.Api.Container.html","title":"DockerEngineAPI.Api.Container","type":"module"},{"doc":"Get an archive of a filesystem resource in a container\nGet a tar archive of a resource in the filesystem of container id.","ref":"DockerEngineAPI.Api.Container.html#container_archive/4","title":"DockerEngineAPI.Api.Container.container_archive/4","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): ID or name of the container\n- `path` (String.t): Resource in the container’s filesystem to archive.\n- `opts` (keyword): Optional parameters","ref":"DockerEngineAPI.Api.Container.html#container_archive/4-parameters","title":"Parameters - DockerEngineAPI.Api.Container.container_archive/4","type":"function"},{"doc":"- `{:ok, nil}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Container.html#container_archive/4-returns","title":"Returns - DockerEngineAPI.Api.Container.container_archive/4","type":"function"},{"doc":"Get information about files in a container\nA response header `X-Docker-Container-Path-Stat` is returned, containing a base64 - encoded JSON object with some filesystem header information about the path.","ref":"DockerEngineAPI.Api.Container.html#container_archive_info/4","title":"DockerEngineAPI.Api.Container.container_archive_info/4","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): ID or name of the container\n- `path` (String.t): Resource in the container’s filesystem to archive.\n- `opts` (keyword): Optional parameters","ref":"DockerEngineAPI.Api.Container.html#container_archive_info/4-parameters","title":"Parameters - DockerEngineAPI.Api.Container.container_archive_info/4","type":"function"},{"doc":"- `{:ok, nil}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Container.html#container_archive_info/4-returns","title":"Returns - DockerEngineAPI.Api.Container.container_archive_info/4","type":"function"},{"doc":"Attach to a container\nAttach to a container to read its output or send it input. You can attach to the same container multiple times and you can reattach to containers that have been detached.  Either the `stream` or `logs` parameter must be `true` for this endpoint to do anything.  See the [documentation for the `docker attach` command](https://docs.docker.com/engine/reference/commandline/attach/) for more details.","ref":"DockerEngineAPI.Api.Container.html#container_attach/3","title":"DockerEngineAPI.Api.Container.container_attach/3","type":"function"},{"doc":"","ref":"DockerEngineAPI.Api.Container.html#container_attach/3-hijacking-this-endpoint-hijacks-the-http-connection-to-transport-stdin-stdout-and-stderr-on-the-same-socket-this-is-the-response-from-the-daemon-for-an-attach-request-http-1-1-200-ok-content-type-application-vnd-docker-raw-stream-stream-after-the-headers-and-two-new-lines-the-tcp-connection-can-now-be-used-for-raw-bidirectional-communication-between-the-client-and-server-to-hint-potential-proxies-about-connection-hijacking-the-docker-client-can-also-optionally-send-connection-upgrade-headers-for-example-the-client-sends-this-request-to-upgrade-the-connection-post-containers-16253994b7c4-attach-stream-1-stdout-1-http-1-1-upgrade-tcp-connection-upgrade-the-docker-daemon-will-respond-with-a-101-upgraded-response-and-will-similarly-follow-with-the-raw-stream-http-1-1-101-upgraded-content-type-application-vnd-docker-raw-stream-connection-upgrade-upgrade-tcp-stream-stream-format-when-the-tty-setting-is-disabled-in-post-containers-create-operation-containercreate-the-http-content-type-header-is-set-to-application-vnd-docker-multiplexed-stream-and-the-stream-over-the-hijacked-connected-is-multiplexed-to-separate-out-stdout-and-stderr-the-stream-consists-of-a-series-of-frames-each-containing-a-header-and-a-payload-the-header-contains-the-information-which-the-stream-writes-stdout-or-stderr-it-also-contains-the-size-of-the-associated-frame-encoded-in-the-last-four-bytes-uint32-it-is-encoded-on-the-first-eight-bytes-like-this-go-header-8-byte-stream_type-0-0-0-size1-size2-size3-size4-stream_type-can-be-0-stdin-is-written-on-stdout-1-stdout-2-stderr-size1-size2-size3-size4-are-the-four-bytes-of-the-uint32-size-encoded-as-big-endian-following-the-header-is-the-payload-which-is-the-specified-number-of-bytes-of-stream_type-the-simplest-way-to-implement-this-protocol-is-the-following-1-read-8-bytes-2-choose-stdout-or-stderr-depending-on-the-first-byte-3-extract-the-frame-size-from-the-last-four-bytes-4-read-the-extracted-size-and-output-it-on-the-correct-output-5-goto-1-stream-format-when-using-a-tty-when-the-tty-setting-is-enabled-in-post-containers-create-operation-containercreate-the-stream-is-not-multiplexed-the-data-exchanged-over-the-hijacked-connection-is-simply-the-raw-data-from-the-process-pty-and-client-s-stdin","title":"Hijacking  This endpoint hijacks the HTTP connection to transport `stdin`, `stdout`, and `stderr` on the same socket.  This is the response from the daemon for an attach request:  ``` HTTP/1.1 200 OK Content-Type: application/vnd.docker.raw-stream  [STREAM] ```  After the headers and two new lines, the TCP connection can now be used for raw, bidirectional communication between the client and server.  To hint potential proxies about connection hijacking, the Docker client can also optionally send connection upgrade headers.  For example, the client sends this request to upgrade the connection:  ``` POST /containers/16253994b7c4/attach?stream=1&stdout=1 HTTP/1.1 Upgrade: tcp Connection: Upgrade ```  The Docker daemon will respond with a `101 UPGRADED` response, and will similarly follow with the raw stream:  ``` HTTP/1.1 101 UPGRADED Content-Type: application/vnd.docker.raw-stream Connection: Upgrade Upgrade: tcp  [STREAM] ```  ### Stream format  When the TTY setting is disabled in [`POST /containers/create`](#operation/ContainerCreate), the HTTP Content-Type header is set to application/vnd.docker.multiplexed-stream and the stream over the hijacked connected is multiplexed to separate out `stdout` and `stderr`. The stream consists of a series of frames, each containing a header and a payload.  The header contains the information which the stream writes (`stdout` or `stderr`). It also contains the size of the associated frame encoded in the last four bytes (`uint32`).  It is encoded on the first eight bytes like this:  ```go header := [8]byte{STREAM_TYPE, 0, 0, 0, SIZE1, SIZE2, SIZE3, SIZE4} ```  `STREAM_TYPE` can be:  - 0: `stdin` (is written on `stdout`) - 1: `stdout` - 2: `stderr`  `SIZE1, SIZE2, SIZE3, SIZE4` are the four bytes of the `uint32` size encoded as big endian.  Following the header is the payload, which is the specified number of bytes of `STREAM_TYPE`.  The simplest way to implement this protocol is the following:  1. Read 8 bytes. 2. Choose `stdout` or `stderr` depending on the first byte. 3. Extract the frame size from the last four bytes. 4. Read the extracted size and output it on the correct output. 5. Goto 1.  ### Stream format when using a TTY  When the TTY setting is enabled in [`POST /containers/create`](#operation/ContainerCreate), the stream is not multiplexed. The data exchanged over the hijacked connection is simply the raw data from the process PTY and client's `stdin`. - DockerEngineAPI.Api.Container.container_attach/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): ID or name of the container\n- `opts` (keyword): Optional parameters\n  - `:detachKeys` (String.t): Override the key sequence for detaching a container.Format is a single character `[a-Z]` or `ctrl- ` where ` ` is one of: `a-z`, `@`, `^`, `[`, `,` or `_`.\n  - `:logs` (boolean()): Replay previous logs from the container.  This is useful for attaching to a container that has started and you want to output everything since the container started.  If `stream` is also enabled, once all the previous output has been returned, it will seamlessly transition into streaming current output.\n  - `:stream` (boolean()): Stream attached streams from the time the request was made onwards.\n  - `:stdin` (boolean()): Attach to `stdin`\n  - `:stdout` (boolean()): Attach to `stdout`\n  - `:stderr` (boolean()): Attach to `stderr`","ref":"DockerEngineAPI.Api.Container.html#container_attach/3-parameters","title":"Parameters - DockerEngineAPI.Api.Container.container_attach/3","type":"function"},{"doc":"- `{:ok, nil}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Container.html#container_attach/3-returns","title":"Returns - DockerEngineAPI.Api.Container.container_attach/3","type":"function"},{"doc":"Attach to a container via a websocket","ref":"DockerEngineAPI.Api.Container.html#container_attach_websocket/3","title":"DockerEngineAPI.Api.Container.container_attach_websocket/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): ID or name of the container\n- `opts` (keyword): Optional parameters\n  - `:detachKeys` (String.t): Override the key sequence for detaching a container.Format is a single character `[a-Z]` or `ctrl- ` where ` ` is one of: `a-z`, `@`, `^`, `[`, `,`, or `_`.\n  - `:logs` (boolean()): Return logs\n  - `:stream` (boolean()): Return stream\n  - `:stdin` (boolean()): Attach to `stdin`\n  - `:stdout` (boolean()): Attach to `stdout`\n  - `:stderr` (boolean()): Attach to `stderr`","ref":"DockerEngineAPI.Api.Container.html#container_attach_websocket/3-parameters","title":"Parameters - DockerEngineAPI.Api.Container.container_attach_websocket/3","type":"function"},{"doc":"- `{:ok, nil}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Container.html#container_attach_websocket/3-returns","title":"Returns - DockerEngineAPI.Api.Container.container_attach_websocket/3","type":"function"},{"doc":"Get changes on a container’s filesystem\nReturns which files in a container's filesystem have been added, deleted, or modified. The `Kind` of modification can be one of:  - `0`: Modified (\"C\") - `1`: Added (\"A\") - `2`: Deleted (\"D\")","ref":"DockerEngineAPI.Api.Container.html#container_changes/3","title":"DockerEngineAPI.Api.Container.container_changes/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): ID or name of the container\n- `opts` (keyword): Optional parameters","ref":"DockerEngineAPI.Api.Container.html#container_changes/3-parameters","title":"Parameters - DockerEngineAPI.Api.Container.container_changes/3","type":"function"},{"doc":"- `{:ok, [%FilesystemChange{}, ...]}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Container.html#container_changes/3-returns","title":"Returns - DockerEngineAPI.Api.Container.container_changes/3","type":"function"},{"doc":"Create a container","ref":"DockerEngineAPI.Api.Container.html#container_create/3","title":"DockerEngineAPI.Api.Container.container_create/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `body` (ContainerCreateRequest): Container to create\n- `opts` (keyword): Optional parameters\n  - `:name` (String.t): Assign the specified name to the container. Must match `/?[a-zA-Z0-9][a-zA-Z0-9_.-]+`.\n  - `:platform` (String.t): Platform in the format `os[/arch[/variant]]` used for image lookup.  When specified, the daemon checks if the requested image is present in the local image cache with the given OS and Architecture, and otherwise returns a `404` status.  If the option is not set, the host's native OS and Architecture are used to look up the image in the image cache. However, if no platform is passed and the given image does exist in the local image cache, but its OS or architecture does not match, the container is created with the available image, and a warning is added to the `Warnings` field in the response, for example;      WARNING: The requested image's platform (linux/arm64/v8) does not              match the detected host platform (linux/amd64) and no              specific platform was requested","ref":"DockerEngineAPI.Api.Container.html#container_create/3-parameters","title":"Parameters - DockerEngineAPI.Api.Container.container_create/3","type":"function"},{"doc":"- `{:ok, DockerEngineAPI.Model.ContainerCreateResponse.t}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Container.html#container_create/3-returns","title":"Returns - DockerEngineAPI.Api.Container.container_create/3","type":"function"},{"doc":"Remove a container","ref":"DockerEngineAPI.Api.Container.html#container_delete/3","title":"DockerEngineAPI.Api.Container.container_delete/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): ID or name of the container\n- `opts` (keyword): Optional parameters\n  - `:v` (boolean()): Remove anonymous volumes associated with the container.\n  - `:force` (boolean()): If the container is running, kill it before removing it.\n  - `:link` (boolean()): Remove the specified link associated with the container.","ref":"DockerEngineAPI.Api.Container.html#container_delete/3-parameters","title":"Parameters - DockerEngineAPI.Api.Container.container_delete/3","type":"function"},{"doc":"- `{:ok, nil}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Container.html#container_delete/3-returns","title":"Returns - DockerEngineAPI.Api.Container.container_delete/3","type":"function"},{"doc":"Export a container\nExport the contents of a container as a tarball.","ref":"DockerEngineAPI.Api.Container.html#container_export/3","title":"DockerEngineAPI.Api.Container.container_export/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): ID or name of the container\n- `opts` (keyword): Optional parameters","ref":"DockerEngineAPI.Api.Container.html#container_export/3-parameters","title":"Parameters - DockerEngineAPI.Api.Container.container_export/3","type":"function"},{"doc":"- `{:ok, nil}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Container.html#container_export/3-returns","title":"Returns - DockerEngineAPI.Api.Container.container_export/3","type":"function"},{"doc":"Inspect a container\nReturn low-level information about a container.","ref":"DockerEngineAPI.Api.Container.html#container_inspect/3","title":"DockerEngineAPI.Api.Container.container_inspect/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): ID or name of the container\n- `opts` (keyword): Optional parameters\n  - `:size` (boolean()): Return the size of container as fields `SizeRw` and `SizeRootFs`","ref":"DockerEngineAPI.Api.Container.html#container_inspect/3-parameters","title":"Parameters - DockerEngineAPI.Api.Container.container_inspect/3","type":"function"},{"doc":"- `{:ok, DockerEngineAPI.Model.ContainerInspectResponse.t}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Container.html#container_inspect/3-returns","title":"Returns - DockerEngineAPI.Api.Container.container_inspect/3","type":"function"},{"doc":"Kill a container\nSend a POSIX signal to a container, defaulting to killing to the container.","ref":"DockerEngineAPI.Api.Container.html#container_kill/3","title":"DockerEngineAPI.Api.Container.container_kill/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): ID or name of the container\n- `opts` (keyword): Optional parameters\n  - `:signal` (String.t): Signal to send to the container as an integer or string (e.g. `SIGINT`).","ref":"DockerEngineAPI.Api.Container.html#container_kill/3-parameters","title":"Parameters - DockerEngineAPI.Api.Container.container_kill/3","type":"function"},{"doc":"- `{:ok, nil}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Container.html#container_kill/3-returns","title":"Returns - DockerEngineAPI.Api.Container.container_kill/3","type":"function"},{"doc":"List containers\nReturns a list of containers. For details on the format, see the [inspect endpoint](#operation/ContainerInspect).  Note that it uses a different, smaller representation of a container than inspecting a single container. For example, the list of linked containers is not propagated .","ref":"DockerEngineAPI.Api.Container.html#container_list/2","title":"DockerEngineAPI.Api.Container.container_list/2","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `opts` (keyword): Optional parameters\n  - `:all` (boolean()): Return all containers. By default, only running containers are shown.\n  - `:limit` (integer()): Return this number of most recently created containers, including non-running ones.\n  - `:size` (boolean()): Return the size of container as fields `SizeRw` and `SizeRootFs`.\n  - `:filters` (String.t): Filters to process on the container list, encoded as JSON (a `map[string][]string`). For example, `{\"status\": [\"paused\"]}` will only return paused containers.  Available filters:  - `ancestor`=(` [: ]`, ` `, or ` `) - `before`=(` ` or ` `) - `expose`=(` [/ ]`|` /[ ]`) - `exited= ` containers with exit code of ` ` - `health`=(`starting`|`healthy`|`unhealthy`|`none`) - `id= ` a container's ID - `isolation=`(`default`|`process`|`hyperv`) (Windows daemon only) - `is-task=`(`true`|`false`) - `label=key` or `label=\"key=value\"` of a container label - `name= ` a container's name - `network`=(` ` or ` `) - `publish`=(` [/ ]`|` /[ ]`) - `since`=(` ` or ` `) - `status=`(`created`|`restarting`|`running`|`removing`|`paused`|`exited`|`dead`) - `volume`=(` ` or ` `)","ref":"DockerEngineAPI.Api.Container.html#container_list/2-parameters","title":"Parameters - DockerEngineAPI.Api.Container.container_list/2","type":"function"},{"doc":"Get container logs\nGet `stdout` and `stderr` logs from a container.  Note: This endpoint works only for containers with the `json-file` or `journald` logging driver.","ref":"DockerEngineAPI.Api.Container.html#container_logs/3","title":"DockerEngineAPI.Api.Container.container_logs/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): ID or name of the container\n- `opts` (keyword): Optional parameters\n  - `:follow` (boolean()): Keep connection after returning logs.\n  - `:stdout` (boolean()): Return logs from `stdout`\n  - `:stderr` (boolean()): Return logs from `stderr`\n  - `:since` (integer()): Only return logs since this time, as a UNIX timestamp\n  - `:until` (integer()): Only return logs before this time, as a UNIX timestamp\n  - `:timestamps` (boolean()): Add timestamps to every log line\n  - `:tail` (String.t): Only return this number of log lines from the end of the logs. Specify as an integer or `all` to output all log lines.","ref":"DockerEngineAPI.Api.Container.html#container_logs/3-parameters","title":"Parameters - DockerEngineAPI.Api.Container.container_logs/3","type":"function"},{"doc":"Pause a container\nUse the freezer cgroup to suspend all processes in a container.  Traditionally, when suspending a process the `SIGSTOP` signal is used, which is observable by the process being suspended. With the freezer cgroup the process is unaware, and unable to capture, that it is being suspended, and subsequently resumed.","ref":"DockerEngineAPI.Api.Container.html#container_pause/3","title":"DockerEngineAPI.Api.Container.container_pause/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): ID or name of the container\n- `opts` (keyword): Optional parameters","ref":"DockerEngineAPI.Api.Container.html#container_pause/3-parameters","title":"Parameters - DockerEngineAPI.Api.Container.container_pause/3","type":"function"},{"doc":"- `{:ok, nil}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Container.html#container_pause/3-returns","title":"Returns - DockerEngineAPI.Api.Container.container_pause/3","type":"function"},{"doc":"Delete stopped containers","ref":"DockerEngineAPI.Api.Container.html#container_prune/2","title":"DockerEngineAPI.Api.Container.container_prune/2","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `opts` (keyword): Optional parameters\n  - `:filters` (String.t): Filters to process on the prune list, encoded as JSON (a `map[string][]string`).  Available filters: - `until= ` Prune containers created before this timestamp. The ` ` can be Unix timestamps, date formatted timestamps, or Go duration strings (e.g. `10m`, `1h30m`) computed relative to the daemon machine’s time. - `label` (`label= `, `label= = `, `label!= `, or `label!= = `) Prune containers with (or without, in case `label!=...` is used) the specified labels.","ref":"DockerEngineAPI.Api.Container.html#container_prune/2-parameters","title":"Parameters - DockerEngineAPI.Api.Container.container_prune/2","type":"function"},{"doc":"- `{:ok, DockerEngineAPI.Model.ContainerPruneResponse.t}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Container.html#container_prune/2-returns","title":"Returns - DockerEngineAPI.Api.Container.container_prune/2","type":"function"},{"doc":"Rename a container","ref":"DockerEngineAPI.Api.Container.html#container_rename/4","title":"DockerEngineAPI.Api.Container.container_rename/4","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): ID or name of the container\n- `name` (String.t): New name for the container\n- `opts` (keyword): Optional parameters","ref":"DockerEngineAPI.Api.Container.html#container_rename/4-parameters","title":"Parameters - DockerEngineAPI.Api.Container.container_rename/4","type":"function"},{"doc":"- `{:ok, nil}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Container.html#container_rename/4-returns","title":"Returns - DockerEngineAPI.Api.Container.container_rename/4","type":"function"},{"doc":"Resize a container TTY\nResize the TTY for a container.","ref":"DockerEngineAPI.Api.Container.html#container_resize/3","title":"DockerEngineAPI.Api.Container.container_resize/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): ID or name of the container\n- `opts` (keyword): Optional parameters\n  - `:h` (integer()): Height of the TTY session in characters\n  - `:w` (integer()): Width of the TTY session in characters","ref":"DockerEngineAPI.Api.Container.html#container_resize/3-parameters","title":"Parameters - DockerEngineAPI.Api.Container.container_resize/3","type":"function"},{"doc":"- `{:ok, nil}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Container.html#container_resize/3-returns","title":"Returns - DockerEngineAPI.Api.Container.container_resize/3","type":"function"},{"doc":"Restart a container","ref":"DockerEngineAPI.Api.Container.html#container_restart/3","title":"DockerEngineAPI.Api.Container.container_restart/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): ID or name of the container\n- `opts` (keyword): Optional parameters\n  - `:signal` (String.t): Signal to send to the container as an integer or string (e.g. `SIGINT`).\n  - `:t` (integer()): Number of seconds to wait before killing the container","ref":"DockerEngineAPI.Api.Container.html#container_restart/3-parameters","title":"Parameters - DockerEngineAPI.Api.Container.container_restart/3","type":"function"},{"doc":"- `{:ok, nil}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Container.html#container_restart/3-returns","title":"Returns - DockerEngineAPI.Api.Container.container_restart/3","type":"function"},{"doc":"Start a container","ref":"DockerEngineAPI.Api.Container.html#container_start/3","title":"DockerEngineAPI.Api.Container.container_start/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): ID or name of the container\n- `opts` (keyword): Optional parameters\n  - `:detachKeys` (String.t): Override the key sequence for detaching a container. Format is a single character `[a-Z]` or `ctrl- ` where ` ` is one of: `a-z`, `@`, `^`, `[`, `,` or `_`.","ref":"DockerEngineAPI.Api.Container.html#container_start/3-parameters","title":"Parameters - DockerEngineAPI.Api.Container.container_start/3","type":"function"},{"doc":"- `{:ok, nil}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Container.html#container_start/3-returns","title":"Returns - DockerEngineAPI.Api.Container.container_start/3","type":"function"},{"doc":"Get container stats based on resource usage\nThis endpoint returns a live stream of a container’s resource usage statistics.  The `precpu_stats` is the CPU statistic of the *previous* read, and is used to calculate the CPU usage percentage. It is not an exact copy of the `cpu_stats` field.  If either `precpu_stats.online_cpus` or `cpu_stats.online_cpus` is nil then for compatibility with older daemons the length of the corresponding `cpu_usage.percpu_usage` array should be used.  On a cgroup v2 host, the following fields are not set * `blkio_stats`: all fields other than `io_service_bytes_recursive` * `cpu_stats`: `cpu_usage.percpu_usage` * `memory_stats`: `max_usage` and `failcnt` Also, `memory_stats.stats` fields are incompatible with cgroup v1.  To calculate the values shown by the `stats` command of the docker cli tool the following formulas can be used: * used_memory = `memory_stats.usage - memory_stats.stats.cache` * available_memory = `memory_stats.limit` * Memory usage % = `(used_memory / available_memory) * 100.0` * cpu_delta = `cpu_stats.cpu_usage.total_usage - precpu_stats.cpu_usage.total_usage` * system_cpu_delta = `cpu_stats.system_cpu_usage - precpu_stats.system_cpu_usage` * number_cpus = `lenght(cpu_stats.cpu_usage.percpu_usage)` or `cpu_stats.online_cpus` * CPU usage % = `(cpu_delta / system_cpu_delta) * number_cpus * 100.0`","ref":"DockerEngineAPI.Api.Container.html#container_stats/3","title":"DockerEngineAPI.Api.Container.container_stats/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): ID or name of the container\n- `opts` (keyword): Optional parameters\n  - `:stream` (boolean()): Stream the output. If false, the stats will be output once and then it will disconnect.\n  - `:\"one-shot\"` (boolean()): Only get a single stat instead of waiting for 2 cycles. Must be used with `stream=false`.","ref":"DockerEngineAPI.Api.Container.html#container_stats/3-parameters","title":"Parameters - DockerEngineAPI.Api.Container.container_stats/3","type":"function"},{"doc":"- `{:ok, map()}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Container.html#container_stats/3-returns","title":"Returns - DockerEngineAPI.Api.Container.container_stats/3","type":"function"},{"doc":"Stop a container","ref":"DockerEngineAPI.Api.Container.html#container_stop/3","title":"DockerEngineAPI.Api.Container.container_stop/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): ID or name of the container\n- `opts` (keyword): Optional parameters\n  - `:signal` (String.t): Signal to send to the container as an integer or string (e.g. `SIGINT`).\n  - `:t` (integer()): Number of seconds to wait before killing the container","ref":"DockerEngineAPI.Api.Container.html#container_stop/3-parameters","title":"Parameters - DockerEngineAPI.Api.Container.container_stop/3","type":"function"},{"doc":"- `{:ok, nil}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Container.html#container_stop/3-returns","title":"Returns - DockerEngineAPI.Api.Container.container_stop/3","type":"function"},{"doc":"List processes running inside a container\nOn Unix systems, this is done by running the `ps` command. This endpoint is not supported on Windows.","ref":"DockerEngineAPI.Api.Container.html#container_top/3","title":"DockerEngineAPI.Api.Container.container_top/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): ID or name of the container\n- `opts` (keyword): Optional parameters\n  - `:ps_args` (String.t): The arguments to pass to `ps`. For example, `aux`","ref":"DockerEngineAPI.Api.Container.html#container_top/3-parameters","title":"Parameters - DockerEngineAPI.Api.Container.container_top/3","type":"function"},{"doc":"- `{:ok, DockerEngineAPI.Model.ContainerTopResponse.t}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Container.html#container_top/3-returns","title":"Returns - DockerEngineAPI.Api.Container.container_top/3","type":"function"},{"doc":"Unpause a container\nResume a container which has been paused.","ref":"DockerEngineAPI.Api.Container.html#container_unpause/3","title":"DockerEngineAPI.Api.Container.container_unpause/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): ID or name of the container\n- `opts` (keyword): Optional parameters","ref":"DockerEngineAPI.Api.Container.html#container_unpause/3-parameters","title":"Parameters - DockerEngineAPI.Api.Container.container_unpause/3","type":"function"},{"doc":"- `{:ok, nil}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Container.html#container_unpause/3-returns","title":"Returns - DockerEngineAPI.Api.Container.container_unpause/3","type":"function"},{"doc":"Update a container\nChange various configuration options of a container without having to recreate it.","ref":"DockerEngineAPI.Api.Container.html#container_update/4","title":"DockerEngineAPI.Api.Container.container_update/4","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): ID or name of the container\n- `update` (ContainerUpdateRequest):\n- `opts` (keyword): Optional parameters","ref":"DockerEngineAPI.Api.Container.html#container_update/4-parameters","title":"Parameters - DockerEngineAPI.Api.Container.container_update/4","type":"function"},{"doc":"- `{:ok, DockerEngineAPI.Model.ContainerUpdateResponse.t}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Container.html#container_update/4-returns","title":"Returns - DockerEngineAPI.Api.Container.container_update/4","type":"function"},{"doc":"Wait for a container\nBlock until a container stops, then returns the exit code.","ref":"DockerEngineAPI.Api.Container.html#container_wait/3","title":"DockerEngineAPI.Api.Container.container_wait/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): ID or name of the container\n- `opts` (keyword): Optional parameters\n  - `:condition` (String.t): Wait until a container state reaches the given condition.  Defaults to `not-running` if omitted or empty.","ref":"DockerEngineAPI.Api.Container.html#container_wait/3-parameters","title":"Parameters - DockerEngineAPI.Api.Container.container_wait/3","type":"function"},{"doc":"- `{:ok, DockerEngineAPI.Model.ContainerWaitResponse.t}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Container.html#container_wait/3-returns","title":"Returns - DockerEngineAPI.Api.Container.container_wait/3","type":"function"},{"doc":"Extract an archive of files or folders to a directory in a container\nUpload a tar archive to be extracted to a path in the filesystem of container id. `path` parameter is asserted to be a directory. If it exists as a file, 400 error will be returned with message \"not a directory\".","ref":"DockerEngineAPI.Api.Container.html#put_container_archive/5","title":"DockerEngineAPI.Api.Container.put_container_archive/5","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): ID or name of the container\n- `path` (String.t): Path to a directory in the container to extract the archive’s contents into.\n- `input_stream` (String.t): The input stream must be a tar archive compressed with one of the following algorithms: `identity` (no compression), `gzip`, `bzip2`, or `xz`.\n- `opts` (keyword): Optional parameters\n  - `:noOverwriteDirNonDir` (String.t): If `1`, `true`, or `True` then it will be an error if unpacking the given content would cause an existing directory to be replaced with a non-directory and vice versa.\n  - `:copyUIDGID` (String.t): If `1`, `true`, then it will copy UID/GID maps to the dest file or dir","ref":"DockerEngineAPI.Api.Container.html#put_container_archive/5-parameters","title":"Parameters - DockerEngineAPI.Api.Container.put_container_archive/5","type":"function"},{"doc":"- `{:ok, nil}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Container.html#put_container_archive/5-returns","title":"Returns - DockerEngineAPI.Api.Container.put_container_archive/5","type":"function"},{"doc":"API calls for all endpoints tagged `Exec`.","ref":"DockerEngineAPI.Api.Exec.html","title":"DockerEngineAPI.Api.Exec","type":"module"},{"doc":"Create an exec instance\nRun a command inside a running container.","ref":"DockerEngineAPI.Api.Exec.html#container_exec/4","title":"DockerEngineAPI.Api.Exec.container_exec/4","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): ID or name of container\n- `exec_config` (ExecConfig): Exec configuration\n- `opts` (keyword): Optional parameters","ref":"DockerEngineAPI.Api.Exec.html#container_exec/4-parameters","title":"Parameters - DockerEngineAPI.Api.Exec.container_exec/4","type":"function"},{"doc":"- `{:ok, DockerEngineAPI.Model.IdResponse.t}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Exec.html#container_exec/4-returns","title":"Returns - DockerEngineAPI.Api.Exec.container_exec/4","type":"function"},{"doc":"Inspect an exec instance\nReturn low-level information about an exec instance.","ref":"DockerEngineAPI.Api.Exec.html#exec_inspect/3","title":"DockerEngineAPI.Api.Exec.exec_inspect/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): Exec instance ID\n- `opts` (keyword): Optional parameters","ref":"DockerEngineAPI.Api.Exec.html#exec_inspect/3-parameters","title":"Parameters - DockerEngineAPI.Api.Exec.exec_inspect/3","type":"function"},{"doc":"- `{:ok, DockerEngineAPI.Model.ExecInspectResponse.t}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Exec.html#exec_inspect/3-returns","title":"Returns - DockerEngineAPI.Api.Exec.exec_inspect/3","type":"function"},{"doc":"Resize an exec instance\nResize the TTY session used by an exec instance. This endpoint only works if `tty` was specified as part of creating and starting the exec instance.","ref":"DockerEngineAPI.Api.Exec.html#exec_resize/3","title":"DockerEngineAPI.Api.Exec.exec_resize/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): Exec instance ID\n- `opts` (keyword): Optional parameters\n  - `:h` (integer()): Height of the TTY session in characters\n  - `:w` (integer()): Width of the TTY session in characters","ref":"DockerEngineAPI.Api.Exec.html#exec_resize/3-parameters","title":"Parameters - DockerEngineAPI.Api.Exec.exec_resize/3","type":"function"},{"doc":"- `{:ok, nil}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Exec.html#exec_resize/3-returns","title":"Returns - DockerEngineAPI.Api.Exec.exec_resize/3","type":"function"},{"doc":"Start an exec instance\nStarts a previously set up exec instance. If detach is true, this endpoint returns immediately after starting the command. Otherwise, it sets up an interactive session with the command.","ref":"DockerEngineAPI.Api.Exec.html#exec_start/3","title":"DockerEngineAPI.Api.Exec.exec_start/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): Exec instance ID\n- `opts` (keyword): Optional parameters\n  - `:body` (ExecStartConfig):","ref":"DockerEngineAPI.Api.Exec.html#exec_start/3-parameters","title":"Parameters - DockerEngineAPI.Api.Exec.exec_start/3","type":"function"},{"doc":"- `{:ok, nil}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Exec.html#exec_start/3-returns","title":"Returns - DockerEngineAPI.Api.Exec.exec_start/3","type":"function"},{"doc":"API calls for all endpoints tagged `Image`.","ref":"DockerEngineAPI.Api.Image.html","title":"DockerEngineAPI.Api.Image","type":"module"},{"doc":"Delete builder cache","ref":"DockerEngineAPI.Api.Image.html#build_prune/2","title":"DockerEngineAPI.Api.Image.build_prune/2","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `opts` (keyword): Optional parameters\n  - `:\"keep-storage\"` (integer()): Amount of disk space in bytes to keep for cache\n  - `:all` (boolean()): Remove all types of build cache\n  - `:filters` (String.t): A JSON encoded value of the filters (a `map[string][]string`) to process on the list of build cache objects.  Available filters:  - `until= ` remove cache older than ` `. The ` ` can be Unix timestamps, date formatted timestamps, or Go duration strings (e.g. `10m`, `1h30m`) computed relative to the daemon's local time. - `id= ` - `parent= ` - `type= ` - `description= ` - `inuse` - `shared` - `private`","ref":"DockerEngineAPI.Api.Image.html#build_prune/2-parameters","title":"Parameters - DockerEngineAPI.Api.Image.build_prune/2","type":"function"},{"doc":"- `{:ok, DockerEngineAPI.Model.BuildPruneResponse.t}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Image.html#build_prune/2-returns","title":"Returns - DockerEngineAPI.Api.Image.build_prune/2","type":"function"},{"doc":"Build an image\nBuild an image from a tar archive with a `Dockerfile` in it.  The `Dockerfile` specifies how the image is built from the tar archive. It is typically in the archive's root, but can be at a different path or have a different name by specifying the `dockerfile` parameter. [See the `Dockerfile` reference for more information](https://docs.docker.com/engine/reference/builder/).  The Docker daemon performs a preliminary validation of the `Dockerfile` before starting the build, and returns an error if the syntax is incorrect. After that, each instruction is run one-by-one until the ID of the new image is output.  The build is canceled if the client drops the connection by quitting or being killed.","ref":"DockerEngineAPI.Api.Image.html#image_build/2","title":"DockerEngineAPI.Api.Image.image_build/2","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `opts` (keyword): Optional parameters\n  - `:dockerfile` (String.t): Path within the build context to the `Dockerfile`. This is ignored if `remote` is specified and points to an external `Dockerfile`.\n  - `:t` (String.t): A name and optional tag to apply to the image in the `name:tag` format. If you omit the tag the default `latest` value is assumed. You can provide several `t` parameters.\n  - `:extrahosts` (String.t): Extra hosts to add to /etc/hosts\n  - `:remote` (String.t): A Git repository URI or HTTP/HTTPS context URI. If the URI points to a single text file, the file’s contents are placed into a file called `Dockerfile` and the image is built from that file. If the URI points to a tarball, the file is downloaded by the daemon and the contents therein used as the context for the build. If the URI points to a tarball and the `dockerfile` parameter is also specified, there must be a file with the corresponding path inside the tarball.\n  - `:q` (boolean()): Suppress verbose build output.\n  - `:nocache` (boolean()): Do not use the cache when building the image.\n  - `:cachefrom` (String.t): JSON array of images used for build cache resolution.\n  - `:pull` (String.t): Attempt to pull the image even if an older image exists locally.\n  - `:rm` (boolean()): Remove intermediate containers after a successful build.\n  - `:forcerm` (boolean()): Always remove intermediate containers, even upon failure.\n  - `:memory` (integer()): Set memory limit for build.\n  - `:memswap` (integer()): Total memory (memory + swap). Set as `-1` to disable swap.\n  - `:cpushares` (integer()): CPU shares (relative weight).\n  - `:cpusetcpus` (String.t): CPUs in which to allow execution (e.g., `0-3`, `0,1`).\n  - `:cpuperiod` (integer()): The length of a CPU period in microseconds.\n  - `:cpuquota` (integer()): Microseconds of CPU time that the container can get in a CPU period.\n  - `:buildargs` (String.t): JSON map of string pairs for build-time variables. Users pass these values at build-time. Docker uses the buildargs as the environment context for commands run via the `Dockerfile` RUN instruction, or for variable expansion in other `Dockerfile` instructions. This is not meant for passing secret values.  For example, the build arg `FOO=bar` would become `{\"FOO\":\"bar\"}` in JSON. This would result in the query parameter `buildargs={\"FOO\":\"bar\"}`. Note that `{\"FOO\":\"bar\"}` should be URI component encoded.  [Read more about the buildargs instruction.](https://docs.docker.com/engine/reference/builder/#arg)\n  - `:shmsize` (integer()): Size of `/dev/shm` in bytes. The size must be greater than 0. If omitted the system uses 64MB.\n  - `:squash` (boolean()): Squash the resulting images layers into a single layer. *(Experimental release only.)*\n  - `:labels` (String.t): Arbitrary key/value labels to set on the image, as a JSON map of string pairs.\n  - `:networkmode` (String.t): Sets the networking mode for the run commands during build. Supported standard values are: `bridge`, `host`, `none`, and `container: `. Any other value is taken as a custom network's name or ID to which this container should connect to.\n  - `:\"Content-type\"` (String.t):\n  - `:\"X-Registry-Config\"` (String.t): This is a base64-encoded JSON object with auth configurations for multiple registries that a build may refer to.  The key is a registry URL, and the value is an auth configuration object, [as described in the authentication section](#section/Authentication). For example:  ``` {   \"docker.example.com\": {     \"username\": \"janedoe\",     \"password\": \"hunter2\"   },   \"https://index.docker.io/v1/\": {     \"username\": \"mobydock\",     \"password\": \"conta1n3rize14\"   } } ```  Only the registry domain name (and port if not the default 443) are required. However, for legacy reasons, the Docker Hub registry must be specified with both a `https://` prefix and a `/v1/` suffix even though Docker will prefer to use the v2 registry API.\n  - `:platform` (String.t): Platform in the format os[/arch[/variant]]\n  - `:target` (String.t): Target build stage\n  - `:outputs` (String.t): BuildKit output configuration\n  - `:body` (String.t): A tar archive compressed with one of the following algorithms: identity (no compression), gzip, bzip2, xz.","ref":"DockerEngineAPI.Api.Image.html#image_build/2-parameters","title":"Parameters - DockerEngineAPI.Api.Image.image_build/2","type":"function"},{"doc":"- `{:ok, nil}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Image.html#image_build/2-returns","title":"Returns - DockerEngineAPI.Api.Image.image_build/2","type":"function"},{"doc":"Create a new image from a container","ref":"DockerEngineAPI.Api.Image.html#image_commit/2","title":"DockerEngineAPI.Api.Image.image_commit/2","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `opts` (keyword): Optional parameters\n  - `:container` (String.t): The ID or name of the container to commit\n  - `:repo` (String.t): Repository name for the created image\n  - `:tag` (String.t): Tag name for the create image\n  - `:comment` (String.t): Commit message\n  - `:author` (String.t): Author of the image (e.g., `John Hannibal Smith  `)\n  - `:pause` (boolean()): Whether to pause the container before committing\n  - `:changes` (String.t): `Dockerfile` instructions to apply while committing\n  - `:body` (ContainerConfig): The container configuration","ref":"DockerEngineAPI.Api.Image.html#image_commit/2-parameters","title":"Parameters - DockerEngineAPI.Api.Image.image_commit/2","type":"function"},{"doc":"- `{:ok, DockerEngineAPI.Model.IdResponse.t}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Image.html#image_commit/2-returns","title":"Returns - DockerEngineAPI.Api.Image.image_commit/2","type":"function"},{"doc":"Create an image\nCreate an image by either pulling it from a registry or importing it.","ref":"DockerEngineAPI.Api.Image.html#image_create/2","title":"DockerEngineAPI.Api.Image.image_create/2","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `opts` (keyword): Optional parameters\n  - `:fromImage` (String.t): Name of the image to pull. The name may include a tag or digest. This parameter may only be used when pulling an image. The pull is cancelled if the HTTP connection is closed.\n  - `:fromSrc` (String.t): Source to import. The value may be a URL from which the image can be retrieved or `-` to read the image from the request body. This parameter may only be used when importing an image.\n  - `:repo` (String.t): Repository name given to an image when it is imported. The repo may include a tag. This parameter may only be used when importing an image.\n  - `:tag` (String.t): Tag or digest. If empty when pulling an image, this causes all tags for the given image to be pulled.\n  - `:message` (String.t): Set commit message for imported image.\n  - `:\"X-Registry-Auth\"` (String.t): A base64url-encoded auth configuration.  Refer to the [authentication section](#section/Authentication) for details.\n  - `:changes` ([String.t]): Apply `Dockerfile` instructions to the image that is created, for example: `changes=ENV DEBUG=true`. Note that `ENV DEBUG=true` should be URI component encoded.  Supported `Dockerfile` instructions: `CMD`|`ENTRYPOINT`|`ENV`|`EXPOSE`|`ONBUILD`|`USER`|`VOLUME`|`WORKDIR`\n  - `:platform` (String.t): Platform in the format os[/arch[/variant]].  When used in combination with the `fromImage` option, the daemon checks if the given image is present in the local image cache with the given OS and Architecture, and otherwise attempts to pull the image. If the option is not set, the host's native OS and Architecture are used. If the given image does not exist in the local image cache, the daemon attempts to pull the image with the host's native OS and Architecture. If the given image does exists in the local image cache, but its OS or architecture does not match, a warning is produced.  When used with the `fromSrc` option to import an image from an archive, this option sets the platform information for the imported image. If the option is not set, the host's native OS and Architecture are used for the imported image.\n  - `:body` (String.t): Image content if the value `-` has been specified in fromSrc query parameter","ref":"DockerEngineAPI.Api.Image.html#image_create/2-parameters","title":"Parameters - DockerEngineAPI.Api.Image.image_create/2","type":"function"},{"doc":"- `{:ok, nil}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Image.html#image_create/2-returns","title":"Returns - DockerEngineAPI.Api.Image.image_create/2","type":"function"},{"doc":"Remove an image\nRemove an image, along with any untagged parent images that were referenced by that image.  Images can't be removed if they have descendant images, are being used by a running container or are being used by a build.","ref":"DockerEngineAPI.Api.Image.html#image_delete/3","title":"DockerEngineAPI.Api.Image.image_delete/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `name` (String.t): Image name or ID\n- `opts` (keyword): Optional parameters\n  - `:force` (boolean()): Remove the image even if it is being used by stopped containers or has other tags\n  - `:noprune` (boolean()): Do not delete untagged parent images","ref":"DockerEngineAPI.Api.Image.html#image_delete/3-parameters","title":"Parameters - DockerEngineAPI.Api.Image.image_delete/3","type":"function"},{"doc":"- `{:ok, [%ImageDeleteResponseItem{}, ...]}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Image.html#image_delete/3-returns","title":"Returns - DockerEngineAPI.Api.Image.image_delete/3","type":"function"},{"doc":"Export an image\nGet a tarball containing all images and metadata for a repository.  If `name` is a specific name and tag (e.g. `ubuntu:latest`), then only that image (and its parents) are returned. If `name` is an image ID, similarly only that image (and its parents) are returned, but with the exclusion of the `repositories` file in the tarball, as there were no image names referenced.","ref":"DockerEngineAPI.Api.Image.html#image_get/3","title":"DockerEngineAPI.Api.Image.image_get/3","type":"function"},{"doc":"","ref":"DockerEngineAPI.Api.Image.html#image_get/3-image-tarball-format-an-image-tarball-contains-one-directory-per-image-layer-named-using-its-long-id-each-containing-these-files-version-currently-1-0-the-file-format-version-json-detailed-layer-information-similar-to-docker-inspect-layer_id-layer-tar-a-tarfile-containing-the-filesystem-changes-in-this-layer-the-layer-tar-file-contains-aufs-style-wh-wh-aufs-files-and-directories-for-storing-attribute-changes-and-deletions-if-the-tarball-defines-a-repository-the-tarball-should-also-include-a-repositories-file-at-the-root-that-contains-a-list-of-repository-and-tag-names-mapped-to-layer-ids-json-hello-world-latest-565a9d68a73f6706862bfe8409a7f659776d4d60a8d096eb4a3cbce6999cc2a1","title":"Image tarball format  An image tarball contains one directory per image layer (named using its long ID), each containing these files:  - `VERSION`: currently `1.0` - the file format version - `json`: detailed layer information, similar to `docker inspect layer_id` - `layer.tar`: A tarfile containing the filesystem changes in this layer  The `layer.tar` file contains `aufs` style `.wh..wh.aufs` files and directories for storing attribute changes and deletions.  If the tarball defines a repository, the tarball should also include a `repositories` file at the root that contains a list of repository and tag names mapped to layer IDs.  ```json {   \"hello-world\": {     \"latest\": \"565a9d68a73f6706862bfe8409a7f659776d4d60a8d096eb4a3cbce6999cc2a1\"   } } ``` - DockerEngineAPI.Api.Image.image_get/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `name` (String.t): Image name or ID\n- `opts` (keyword): Optional parameters","ref":"DockerEngineAPI.Api.Image.html#image_get/3-parameters","title":"Parameters - DockerEngineAPI.Api.Image.image_get/3","type":"function"},{"doc":"- `{:ok, String.t}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Image.html#image_get/3-returns","title":"Returns - DockerEngineAPI.Api.Image.image_get/3","type":"function"},{"doc":"Export several images\nGet a tarball containing all images and metadata for several image repositories.  For each value of the `names` parameter: if it is a specific name and tag (e.g. `ubuntu:latest`), then only that image (and its parents) are returned; if it is an image ID, similarly only that image (and its parents) are returned and there would be no names referenced in the 'repositories' file for this image ID.  For details on the format, see the [export image endpoint](#operation/ImageGet).","ref":"DockerEngineAPI.Api.Image.html#image_get_all/2","title":"DockerEngineAPI.Api.Image.image_get_all/2","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `opts` (keyword): Optional parameters\n  - `:names` ([String.t]): Image names to filter by","ref":"DockerEngineAPI.Api.Image.html#image_get_all/2-parameters","title":"Parameters - DockerEngineAPI.Api.Image.image_get_all/2","type":"function"},{"doc":"- `{:ok, String.t}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Image.html#image_get_all/2-returns","title":"Returns - DockerEngineAPI.Api.Image.image_get_all/2","type":"function"},{"doc":"Get the history of an image\nReturn parent layers of an image.","ref":"DockerEngineAPI.Api.Image.html#image_history/3","title":"DockerEngineAPI.Api.Image.image_history/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `name` (String.t): Image name or ID\n- `opts` (keyword): Optional parameters","ref":"DockerEngineAPI.Api.Image.html#image_history/3-parameters","title":"Parameters - DockerEngineAPI.Api.Image.image_history/3","type":"function"},{"doc":"- `{:ok, [%HistoryResponseItem{}, ...]}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Image.html#image_history/3-returns","title":"Returns - DockerEngineAPI.Api.Image.image_history/3","type":"function"},{"doc":"Inspect an image\nReturn low-level information about an image.","ref":"DockerEngineAPI.Api.Image.html#image_inspect/3","title":"DockerEngineAPI.Api.Image.image_inspect/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `name` (String.t): Image name or id\n- `opts` (keyword): Optional parameters","ref":"DockerEngineAPI.Api.Image.html#image_inspect/3-parameters","title":"Parameters - DockerEngineAPI.Api.Image.image_inspect/3","type":"function"},{"doc":"- `{:ok, DockerEngineAPI.Model.ImageInspect.t}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Image.html#image_inspect/3-returns","title":"Returns - DockerEngineAPI.Api.Image.image_inspect/3","type":"function"},{"doc":"List Images\nReturns a list of images on the server. Note that it uses a different, smaller representation of an image than inspecting a single image.","ref":"DockerEngineAPI.Api.Image.html#image_list/2","title":"DockerEngineAPI.Api.Image.image_list/2","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `opts` (keyword): Optional parameters\n  - `:all` (boolean()): Show all images. Only images from a final layer (no children) are shown by default.\n  - `:filters` (String.t): A JSON encoded value of the filters (a `map[string][]string`) to process on the images list.  Available filters:  - `before`=(` [: ]`,  ` ` or ` `) - `dangling=true` - `label=key` or `label=\"key=value\"` of an image label - `reference`=(` [: ]`) - `since`=(` [: ]`,  ` ` or ` `)\n  - `:\"shared-size\"` (boolean()): Compute and show shared size as a `SharedSize` field on each image.\n  - `:digests` (boolean()): Show digest information as a `RepoDigests` field on each image.","ref":"DockerEngineAPI.Api.Image.html#image_list/2-parameters","title":"Parameters - DockerEngineAPI.Api.Image.image_list/2","type":"function"},{"doc":"- `{:ok, [%ImageSummary{}, ...]}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Image.html#image_list/2-returns","title":"Returns - DockerEngineAPI.Api.Image.image_list/2","type":"function"},{"doc":"Import images\nLoad a set of images and tags into a repository.  For details on the format, see the [export image endpoint](#operation/ImageGet).","ref":"DockerEngineAPI.Api.Image.html#image_load/2","title":"DockerEngineAPI.Api.Image.image_load/2","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `opts` (keyword): Optional parameters\n  - `:quiet` (boolean()): Suppress progress details during load.\n  - `:body` (String.t): Tar archive containing images","ref":"DockerEngineAPI.Api.Image.html#image_load/2-parameters","title":"Parameters - DockerEngineAPI.Api.Image.image_load/2","type":"function"},{"doc":"- `{:ok, nil}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Image.html#image_load/2-returns","title":"Returns - DockerEngineAPI.Api.Image.image_load/2","type":"function"},{"doc":"Delete unused images","ref":"DockerEngineAPI.Api.Image.html#image_prune/2","title":"DockerEngineAPI.Api.Image.image_prune/2","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `opts` (keyword): Optional parameters\n  - `:filters` (String.t): Filters to process on the prune list, encoded as JSON (a `map[string][]string`). Available filters:  - `dangling= ` When set to `true` (or `1`), prune only    unused *and* untagged images. When set to `false`    (or `0`), all unused images are pruned. - `until= ` Prune images created before this timestamp. The ` ` can be Unix timestamps, date formatted timestamps, or Go duration strings (e.g. `10m`, `1h30m`) computed relative to the daemon machine’s time. - `label` (`label= `, `label= = `, `label!= `, or `label!= = `) Prune images with (or without, in case `label!=...` is used) the specified labels.","ref":"DockerEngineAPI.Api.Image.html#image_prune/2-parameters","title":"Parameters - DockerEngineAPI.Api.Image.image_prune/2","type":"function"},{"doc":"- `{:ok, DockerEngineAPI.Model.ImagePruneResponse.t}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Image.html#image_prune/2-returns","title":"Returns - DockerEngineAPI.Api.Image.image_prune/2","type":"function"},{"doc":"Push an image\nPush an image to a registry.  If you wish to push an image on to a private registry, that image must already have a tag which references the registry. For example, `registry.example.com/myimage:latest`.  The push is cancelled if the HTTP connection is closed.","ref":"DockerEngineAPI.Api.Image.html#image_push/4","title":"DockerEngineAPI.Api.Image.image_push/4","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `name` (String.t): Image name or ID.\n- `x_registry_auth` (String.t): A base64url-encoded auth configuration.  Refer to the [authentication section](#section/Authentication) for details.\n- `opts` (keyword): Optional parameters\n  - `:tag` (String.t): The tag to associate with the image on the registry.","ref":"DockerEngineAPI.Api.Image.html#image_push/4-parameters","title":"Parameters - DockerEngineAPI.Api.Image.image_push/4","type":"function"},{"doc":"- `{:ok, nil}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Image.html#image_push/4-returns","title":"Returns - DockerEngineAPI.Api.Image.image_push/4","type":"function"},{"doc":"Search images\nSearch for an image on Docker Hub.","ref":"DockerEngineAPI.Api.Image.html#image_search/3","title":"DockerEngineAPI.Api.Image.image_search/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `term` (String.t): Term to search\n- `opts` (keyword): Optional parameters\n  - `:limit` (integer()): Maximum number of results to return\n  - `:filters` (String.t): A JSON encoded value of the filters (a `map[string][]string`) to process on the images list. Available filters:  - `is-automated=(true|false)` - `is-official=(true|false)` - `stars= ` Matches images that has at least 'number' stars.","ref":"DockerEngineAPI.Api.Image.html#image_search/3-parameters","title":"Parameters - DockerEngineAPI.Api.Image.image_search/3","type":"function"},{"doc":"- `{:ok, [%ImageSearchResponseItem{}, ...]}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Image.html#image_search/3-returns","title":"Returns - DockerEngineAPI.Api.Image.image_search/3","type":"function"},{"doc":"Tag an image\nTag an image so that it becomes part of a repository.","ref":"DockerEngineAPI.Api.Image.html#image_tag/3","title":"DockerEngineAPI.Api.Image.image_tag/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `name` (String.t): Image name or ID to tag.\n- `opts` (keyword): Optional parameters\n  - `:repo` (String.t): The repository to tag in. For example, `someuser/someimage`.\n  - `:tag` (String.t): The name of the new tag.","ref":"DockerEngineAPI.Api.Image.html#image_tag/3-parameters","title":"Parameters - DockerEngineAPI.Api.Image.image_tag/3","type":"function"},{"doc":"- `{:ok, nil}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Image.html#image_tag/3-returns","title":"Returns - DockerEngineAPI.Api.Image.image_tag/3","type":"function"},{"doc":"API calls for all endpoints tagged `Network`.","ref":"DockerEngineAPI.Api.Network.html","title":"DockerEngineAPI.Api.Network","type":"module"},{"doc":"Connect a container to a network","ref":"DockerEngineAPI.Api.Network.html#network_connect/4","title":"DockerEngineAPI.Api.Network.network_connect/4","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): Network ID or name\n- `container` (NetworkConnectRequest): \n- `opts` (keyword): Optional parameters","ref":"DockerEngineAPI.Api.Network.html#network_connect/4-parameters","title":"Parameters - DockerEngineAPI.Api.Network.network_connect/4","type":"function"},{"doc":"- `{:ok, nil}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Network.html#network_connect/4-returns","title":"Returns - DockerEngineAPI.Api.Network.network_connect/4","type":"function"},{"doc":"Create a network","ref":"DockerEngineAPI.Api.Network.html#network_create/3","title":"DockerEngineAPI.Api.Network.network_create/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `network_config` (NetworkCreateRequest): Network configuration\n- `opts` (keyword): Optional parameters","ref":"DockerEngineAPI.Api.Network.html#network_create/3-parameters","title":"Parameters - DockerEngineAPI.Api.Network.network_create/3","type":"function"},{"doc":"- `{:ok, DockerEngineAPI.Model.NetworkCreateResponse.t}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Network.html#network_create/3-returns","title":"Returns - DockerEngineAPI.Api.Network.network_create/3","type":"function"},{"doc":"Remove a network","ref":"DockerEngineAPI.Api.Network.html#network_delete/3","title":"DockerEngineAPI.Api.Network.network_delete/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): Network ID or name\n- `opts` (keyword): Optional parameters","ref":"DockerEngineAPI.Api.Network.html#network_delete/3-parameters","title":"Parameters - DockerEngineAPI.Api.Network.network_delete/3","type":"function"},{"doc":"- `{:ok, nil}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Network.html#network_delete/3-returns","title":"Returns - DockerEngineAPI.Api.Network.network_delete/3","type":"function"},{"doc":"Disconnect a container from a network","ref":"DockerEngineAPI.Api.Network.html#network_disconnect/4","title":"DockerEngineAPI.Api.Network.network_disconnect/4","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): Network ID or name\n- `container` (NetworkDisconnectRequest): \n- `opts` (keyword): Optional parameters","ref":"DockerEngineAPI.Api.Network.html#network_disconnect/4-parameters","title":"Parameters - DockerEngineAPI.Api.Network.network_disconnect/4","type":"function"},{"doc":"- `{:ok, nil}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Network.html#network_disconnect/4-returns","title":"Returns - DockerEngineAPI.Api.Network.network_disconnect/4","type":"function"},{"doc":"Inspect a network","ref":"DockerEngineAPI.Api.Network.html#network_inspect/3","title":"DockerEngineAPI.Api.Network.network_inspect/3","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `id` (String.t): Network ID or name\n- `opts` (keyword): Optional parameters\n  - `:verbose` (boolean()): Detailed inspect output for troubleshooting\n  - `:scope` (String.t): Filter the network by scope (swarm, global, or local)","ref":"DockerEngineAPI.Api.Network.html#network_inspect/3-parameters","title":"Parameters - DockerEngineAPI.Api.Network.network_inspect/3","type":"function"},{"doc":"- `{:ok, DockerEngineAPI.Model.Network.t}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Network.html#network_inspect/3-returns","title":"Returns - DockerEngineAPI.Api.Network.network_inspect/3","type":"function"},{"doc":"List networks\nReturns a list of networks. For details on the format, see the [network inspect endpoint](#operation/NetworkInspect).  Note that it uses a different, smaller representation of a network than inspecting a single network. For example, the list of containers attached to the network is not propagated in API versions 1.28 and up.","ref":"DockerEngineAPI.Api.Network.html#network_list/2","title":"DockerEngineAPI.Api.Network.network_list/2","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `opts` (keyword): Optional parameters\n  - `:filters` (String.t): JSON encoded value of the filters (a `map[string][]string`) to process on the networks list.  Available filters:  - `dangling= ` When set to `true` (or `1`), returns all    networks that are not in use by a container. When set to `false`    (or `0`), only networks that are in use by one or more    containers are returned. - `driver= ` Matches a network's driver. - `id= ` Matches all or part of a network ID. - `label= ` or `label= = ` of a network label. - `name= ` Matches all or part of a network name. - `scope=[\"swarm\"|\"global\"|\"local\"]` Filters networks by scope (`swarm`, `global`, or `local`). - `type=[\"custom\"|\"builtin\"]` Filters networks by type. The `custom` keyword returns all user-defined networks.","ref":"DockerEngineAPI.Api.Network.html#network_list/2-parameters","title":"Parameters - DockerEngineAPI.Api.Network.network_list/2","type":"function"},{"doc":"- `{:ok, [%Network{}, ...]}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Network.html#network_list/2-returns","title":"Returns - DockerEngineAPI.Api.Network.network_list/2","type":"function"},{"doc":"Delete unused networks","ref":"DockerEngineAPI.Api.Network.html#network_prune/2","title":"DockerEngineAPI.Api.Network.network_prune/2","type":"function"},{"doc":"- `connection` (DockerEngineAPI.Connection): Connection to server\n- `opts` (keyword): Optional parameters\n  - `:filters` (String.t): Filters to process on the prune list, encoded as JSON (a `map[string][]string`).  Available filters: - `until= ` Prune networks created before this timestamp. The ` ` can be Unix timestamps, date formatted timestamps, or Go duration strings (e.g. `10m`, `1h30m`) computed relative to the daemon machine’s time. - `label` (`label= `, `label= = `, `label!= `, or `label!= = `) Prune networks with (or without, in case `label!=...` is used) the specified labels.","ref":"DockerEngineAPI.Api.Network.html#network_prune/2-parameters","title":"Parameters - DockerEngineAPI.Api.Network.network_prune/2","type":"function"},{"doc":"- `{:ok, DockerEngineAPI.Model.NetworkPruneResponse.t}` on success\n- `{:error, Tesla.Env.t}` on failure","ref":"DockerEngineAPI.Api.Network.html#network_prune/2-returns","title":"Returns - DockerEngineAPI.Api.Network.network_prune/2","type":"function"},{"doc":"Handle Tesla connections for DockerEngineAPI.","ref":"DockerEngineAPI.Connection.html","title":"DockerEngineAPI.Connection","type":"module"},{"doc":"Returns the default adapter for this API.","ref":"DockerEngineAPI.Connection.html#adapter/1","title":"DockerEngineAPI.Connection.adapter/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Connection.html#get_tesla_options/0","title":"DockerEngineAPI.Connection.get_tesla_options/0","type":"function"},{"doc":"Returns fully configured middleware for passing to Tesla.client/2.","ref":"DockerEngineAPI.Connection.html#middleware/1","title":"DockerEngineAPI.Connection.middleware/1","type":"function"},{"doc":"Configure a client that may have authentication.","ref":"DockerEngineAPI.Connection.html#new/1","title":"DockerEngineAPI.Connection.new/1","type":"function"},{"doc":"- `options`: a keyword list of OpenAPIPetstore.Connection.options.","ref":"DockerEngineAPI.Connection.html#new/1-parameters","title":"Parameters - DockerEngineAPI.Connection.new/1","type":"function"},{"doc":"Tesla.Env.client","ref":"DockerEngineAPI.Connection.html#new/1-returns","title":"Returns - DockerEngineAPI.Connection.new/1","type":"function"},{"doc":"Forward requests to Tesla.","ref":"DockerEngineAPI.Connection.html#request/2","title":"DockerEngineAPI.Connection.request/2","type":"function"},{"doc":"The list of options that can be passed to new/1.\n\n- `base_url`: Overrides the base URL on a per-client basis.\n- `user_agent`: Overrides the User-Agent header.","ref":"DockerEngineAPI.Connection.html#t:options/0","title":"DockerEngineAPI.Connection.options/0","type":"type"},{"doc":"Helper functions for deserializing responses into models","ref":"DockerEngineAPI.Deserializer.html","title":"DockerEngineAPI.Deserializer","type":"module"},{"doc":"Update the provided model with a deserialization of a nested value","ref":"DockerEngineAPI.Deserializer.html#deserialize/4","title":"DockerEngineAPI.Deserializer.deserialize/4","type":"function"},{"doc":"","ref":"DockerEngineAPI.Deserializer.html#jason_decode/1","title":"DockerEngineAPI.Deserializer.jason_decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Deserializer.html#jason_decode/2","title":"DockerEngineAPI.Deserializer.jason_decode/2","type":"function"},{"doc":"Address represents an IPv4 or IPv6 IP address.","ref":"DockerEngineAPI.Model.Address.html","title":"DockerEngineAPI.Model.Address","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.Address.html#decode/1","title":"DockerEngineAPI.Model.Address.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.Address.html#t:t/0","title":"DockerEngineAPI.Model.Address.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.BuildPruneResponse.html","title":"DockerEngineAPI.Model.BuildPruneResponse","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.BuildPruneResponse.html#decode/1","title":"DockerEngineAPI.Model.BuildPruneResponse.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.BuildPruneResponse.html#t:t/0","title":"DockerEngineAPI.Model.BuildPruneResponse.t/0","type":"type"},{"doc":"Kind of change  Can be one of:  - `0`: Modified (\"C\") - `1`: Added (\"A\") - `2`: Deleted (\"D\")","ref":"DockerEngineAPI.Model.ChangeType.html","title":"DockerEngineAPI.Model.ChangeType","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ChangeType.html#decode/1","title":"DockerEngineAPI.Model.ChangeType.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ChangeType.html#t:t/0","title":"DockerEngineAPI.Model.ChangeType.t/0","type":"type"},{"doc":"Configuration for a container that is portable between hosts.  When used as `ContainerConfig` field in an image, `ContainerConfig` is an optional field containing the configuration of the container that was last committed when creating the image.  Previous versions of Docker builder used this field to store build cache, and it is not in active use anymore.","ref":"DockerEngineAPI.Model.ContainerConfig.html","title":"DockerEngineAPI.Model.ContainerConfig","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerConfig.html#decode/1","title":"DockerEngineAPI.Model.ContainerConfig.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerConfig.html#t:t/0","title":"DockerEngineAPI.Model.ContainerConfig.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerCreateRequest.html","title":"DockerEngineAPI.Model.ContainerCreateRequest","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerCreateRequest.html#decode/1","title":"DockerEngineAPI.Model.ContainerCreateRequest.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerCreateRequest.html#t:t/0","title":"DockerEngineAPI.Model.ContainerCreateRequest.t/0","type":"type"},{"doc":"OK response to ContainerCreate operation","ref":"DockerEngineAPI.Model.ContainerCreateResponse.html","title":"DockerEngineAPI.Model.ContainerCreateResponse","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerCreateResponse.html#decode/1","title":"DockerEngineAPI.Model.ContainerCreateResponse.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerCreateResponse.html#t:t/0","title":"DockerEngineAPI.Model.ContainerCreateResponse.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerInspectResponse.html","title":"DockerEngineAPI.Model.ContainerInspectResponse","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerInspectResponse.html#decode/1","title":"DockerEngineAPI.Model.ContainerInspectResponse.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerInspectResponse.html#t:t/0","title":"DockerEngineAPI.Model.ContainerInspectResponse.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerPruneResponse.html","title":"DockerEngineAPI.Model.ContainerPruneResponse","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerPruneResponse.html#decode/1","title":"DockerEngineAPI.Model.ContainerPruneResponse.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerPruneResponse.html#t:t/0","title":"DockerEngineAPI.Model.ContainerPruneResponse.t/0","type":"type"},{"doc":"ContainerState stores container's running state. It's part of ContainerJSONBase and will be returned by the \"inspect\" command.","ref":"DockerEngineAPI.Model.ContainerState.html","title":"DockerEngineAPI.Model.ContainerState","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerState.html#decode/1","title":"DockerEngineAPI.Model.ContainerState.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerState.html#t:t/0","title":"DockerEngineAPI.Model.ContainerState.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerSummary.html","title":"DockerEngineAPI.Model.ContainerSummary","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerSummary.html#decode/1","title":"DockerEngineAPI.Model.ContainerSummary.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerSummary.html#t:t/0","title":"DockerEngineAPI.Model.ContainerSummary.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerSummaryHostConfig.html","title":"DockerEngineAPI.Model.ContainerSummaryHostConfig","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerSummaryHostConfig.html#decode/1","title":"DockerEngineAPI.Model.ContainerSummaryHostConfig.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerSummaryHostConfig.html#t:t/0","title":"DockerEngineAPI.Model.ContainerSummaryHostConfig.t/0","type":"type"},{"doc":"A summary of the container's network settings","ref":"DockerEngineAPI.Model.ContainerSummaryNetworkSettings.html","title":"DockerEngineAPI.Model.ContainerSummaryNetworkSettings","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerSummaryNetworkSettings.html#decode/1","title":"DockerEngineAPI.Model.ContainerSummaryNetworkSettings.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerSummaryNetworkSettings.html#t:t/0","title":"DockerEngineAPI.Model.ContainerSummaryNetworkSettings.t/0","type":"type"},{"doc":"OK response to ContainerTop operation","ref":"DockerEngineAPI.Model.ContainerTopResponse.html","title":"DockerEngineAPI.Model.ContainerTopResponse","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerTopResponse.html#decode/1","title":"DockerEngineAPI.Model.ContainerTopResponse.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerTopResponse.html#t:t/0","title":"DockerEngineAPI.Model.ContainerTopResponse.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerUpdateRequest.html","title":"DockerEngineAPI.Model.ContainerUpdateRequest","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerUpdateRequest.html#decode/1","title":"DockerEngineAPI.Model.ContainerUpdateRequest.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerUpdateRequest.html#t:t/0","title":"DockerEngineAPI.Model.ContainerUpdateRequest.t/0","type":"type"},{"doc":"OK response to ContainerUpdate operation","ref":"DockerEngineAPI.Model.ContainerUpdateResponse.html","title":"DockerEngineAPI.Model.ContainerUpdateResponse","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerUpdateResponse.html#decode/1","title":"DockerEngineAPI.Model.ContainerUpdateResponse.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerUpdateResponse.html#t:t/0","title":"DockerEngineAPI.Model.ContainerUpdateResponse.t/0","type":"type"},{"doc":"container waiting error, if any","ref":"DockerEngineAPI.Model.ContainerWaitExitError.html","title":"DockerEngineAPI.Model.ContainerWaitExitError","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerWaitExitError.html#decode/1","title":"DockerEngineAPI.Model.ContainerWaitExitError.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerWaitExitError.html#t:t/0","title":"DockerEngineAPI.Model.ContainerWaitExitError.t/0","type":"type"},{"doc":"OK response to ContainerWait operation","ref":"DockerEngineAPI.Model.ContainerWaitResponse.html","title":"DockerEngineAPI.Model.ContainerWaitResponse","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerWaitResponse.html#decode/1","title":"DockerEngineAPI.Model.ContainerWaitResponse.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ContainerWaitResponse.html#t:t/0","title":"DockerEngineAPI.Model.ContainerWaitResponse.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.CreateImageInfo.html","title":"DockerEngineAPI.Model.CreateImageInfo","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.CreateImageInfo.html#decode/1","title":"DockerEngineAPI.Model.CreateImageInfo.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.CreateImageInfo.html#t:t/0","title":"DockerEngineAPI.Model.CreateImageInfo.t/0","type":"type"},{"doc":"A device mapping between the host and container","ref":"DockerEngineAPI.Model.DeviceMapping.html","title":"DockerEngineAPI.Model.DeviceMapping","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.DeviceMapping.html#decode/1","title":"DockerEngineAPI.Model.DeviceMapping.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.DeviceMapping.html#t:t/0","title":"DockerEngineAPI.Model.DeviceMapping.t/0","type":"type"},{"doc":"A request for devices to be sent to device drivers","ref":"DockerEngineAPI.Model.DeviceRequest.html","title":"DockerEngineAPI.Model.DeviceRequest","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.DeviceRequest.html#decode/1","title":"DockerEngineAPI.Model.DeviceRequest.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.DeviceRequest.html#t:t/0","title":"DockerEngineAPI.Model.DeviceRequest.t/0","type":"type"},{"doc":"EndpointIPAMConfig represents an endpoint's IPAM configuration.","ref":"DockerEngineAPI.Model.EndpointIpamConfig.html","title":"DockerEngineAPI.Model.EndpointIpamConfig","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.EndpointIpamConfig.html#decode/1","title":"DockerEngineAPI.Model.EndpointIpamConfig.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.EndpointIpamConfig.html#t:t/0","title":"DockerEngineAPI.Model.EndpointIpamConfig.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.EndpointPortConfig.html","title":"DockerEngineAPI.Model.EndpointPortConfig","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.EndpointPortConfig.html#decode/1","title":"DockerEngineAPI.Model.EndpointPortConfig.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.EndpointPortConfig.html#t:t/0","title":"DockerEngineAPI.Model.EndpointPortConfig.t/0","type":"type"},{"doc":"Configuration for a network endpoint.","ref":"DockerEngineAPI.Model.EndpointSettings.html","title":"DockerEngineAPI.Model.EndpointSettings","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.EndpointSettings.html#decode/1","title":"DockerEngineAPI.Model.EndpointSettings.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.EndpointSettings.html#t:t/0","title":"DockerEngineAPI.Model.EndpointSettings.t/0","type":"type"},{"doc":"Properties that can be configured to access and load balance a service.","ref":"DockerEngineAPI.Model.EndpointSpec.html","title":"DockerEngineAPI.Model.EndpointSpec","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.EndpointSpec.html#decode/1","title":"DockerEngineAPI.Model.EndpointSpec.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.EndpointSpec.html#t:t/0","title":"DockerEngineAPI.Model.EndpointSpec.t/0","type":"type"},{"doc":"EngineDescription provides information about an engine.","ref":"DockerEngineAPI.Model.EngineDescription.html","title":"DockerEngineAPI.Model.EngineDescription","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.EngineDescription.html#decode/1","title":"DockerEngineAPI.Model.EngineDescription.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.EngineDescription.html#t:t/0","title":"DockerEngineAPI.Model.EngineDescription.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.EngineDescriptionPluginsInner.html","title":"DockerEngineAPI.Model.EngineDescriptionPluginsInner","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.EngineDescriptionPluginsInner.html#decode/1","title":"DockerEngineAPI.Model.EngineDescriptionPluginsInner.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.EngineDescriptionPluginsInner.html#t:t/0","title":"DockerEngineAPI.Model.EngineDescriptionPluginsInner.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.ErrorDetail.html","title":"DockerEngineAPI.Model.ErrorDetail","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ErrorDetail.html#decode/1","title":"DockerEngineAPI.Model.ErrorDetail.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ErrorDetail.html#t:t/0","title":"DockerEngineAPI.Model.ErrorDetail.t/0","type":"type"},{"doc":"Represents an error.","ref":"DockerEngineAPI.Model.ErrorResponse.html","title":"DockerEngineAPI.Model.ErrorResponse","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ErrorResponse.html#decode/1","title":"DockerEngineAPI.Model.ErrorResponse.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ErrorResponse.html#t:t/0","title":"DockerEngineAPI.Model.ErrorResponse.t/0","type":"type"},{"doc":"Actor describes something that generates events, like a container, network, or a volume.","ref":"DockerEngineAPI.Model.EventActor.html","title":"DockerEngineAPI.Model.EventActor","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.EventActor.html#decode/1","title":"DockerEngineAPI.Model.EventActor.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.EventActor.html#t:t/0","title":"DockerEngineAPI.Model.EventActor.t/0","type":"type"},{"doc":"EventMessage represents the information an event contains.","ref":"DockerEngineAPI.Model.EventMessage.html","title":"DockerEngineAPI.Model.EventMessage","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.EventMessage.html#decode/1","title":"DockerEngineAPI.Model.EventMessage.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.EventMessage.html#t:t/0","title":"DockerEngineAPI.Model.EventMessage.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.ExecConfig.html","title":"DockerEngineAPI.Model.ExecConfig","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ExecConfig.html#decode/1","title":"DockerEngineAPI.Model.ExecConfig.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ExecConfig.html#t:t/0","title":"DockerEngineAPI.Model.ExecConfig.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.ExecInspectResponse.html","title":"DockerEngineAPI.Model.ExecInspectResponse","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ExecInspectResponse.html#decode/1","title":"DockerEngineAPI.Model.ExecInspectResponse.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ExecInspectResponse.html#t:t/0","title":"DockerEngineAPI.Model.ExecInspectResponse.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.ExecStartConfig.html","title":"DockerEngineAPI.Model.ExecStartConfig","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ExecStartConfig.html#decode/1","title":"DockerEngineAPI.Model.ExecStartConfig.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ExecStartConfig.html#t:t/0","title":"DockerEngineAPI.Model.ExecStartConfig.t/0","type":"type"},{"doc":"Change in the container's filesystem.","ref":"DockerEngineAPI.Model.FilesystemChange.html","title":"DockerEngineAPI.Model.FilesystemChange","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.FilesystemChange.html#decode/1","title":"DockerEngineAPI.Model.FilesystemChange.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.FilesystemChange.html#t:t/0","title":"DockerEngineAPI.Model.FilesystemChange.t/0","type":"type"},{"doc":"Information about the storage driver used to store the container's and image's filesystem.","ref":"DockerEngineAPI.Model.GraphDriverData.html","title":"DockerEngineAPI.Model.GraphDriverData","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.GraphDriverData.html#decode/1","title":"DockerEngineAPI.Model.GraphDriverData.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.GraphDriverData.html#t:t/0","title":"DockerEngineAPI.Model.GraphDriverData.t/0","type":"type"},{"doc":"Health stores information about the container's healthcheck results.","ref":"DockerEngineAPI.Model.Health.html","title":"DockerEngineAPI.Model.Health","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.Health.html#decode/1","title":"DockerEngineAPI.Model.Health.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.Health.html#t:t/0","title":"DockerEngineAPI.Model.Health.t/0","type":"type"},{"doc":"A test to perform to check that the container is healthy.","ref":"DockerEngineAPI.Model.HealthConfig.html","title":"DockerEngineAPI.Model.HealthConfig","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.HealthConfig.html#decode/1","title":"DockerEngineAPI.Model.HealthConfig.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.HealthConfig.html#t:t/0","title":"DockerEngineAPI.Model.HealthConfig.t/0","type":"type"},{"doc":"HealthcheckResult stores information about a single run of a healthcheck probe","ref":"DockerEngineAPI.Model.HealthcheckResult.html","title":"DockerEngineAPI.Model.HealthcheckResult","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.HealthcheckResult.html#decode/1","title":"DockerEngineAPI.Model.HealthcheckResult.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.HealthcheckResult.html#t:t/0","title":"DockerEngineAPI.Model.HealthcheckResult.t/0","type":"type"},{"doc":"individual image layer information in response to ImageHistory operation","ref":"DockerEngineAPI.Model.HistoryResponseItem.html","title":"DockerEngineAPI.Model.HistoryResponseItem","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.HistoryResponseItem.html#decode/1","title":"DockerEngineAPI.Model.HistoryResponseItem.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.HistoryResponseItem.html#t:t/0","title":"DockerEngineAPI.Model.HistoryResponseItem.t/0","type":"type"},{"doc":"Container configuration that depends on the host we are running on","ref":"DockerEngineAPI.Model.HostConfig.html","title":"DockerEngineAPI.Model.HostConfig","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.HostConfig.html#decode/1","title":"DockerEngineAPI.Model.HostConfig.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.HostConfig.html#t:t/0","title":"DockerEngineAPI.Model.HostConfig.t/0","type":"type"},{"doc":"The logging configuration for this container","ref":"DockerEngineAPI.Model.HostConfigAllOfLogConfig.html","title":"DockerEngineAPI.Model.HostConfigAllOfLogConfig","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.HostConfigAllOfLogConfig.html#decode/1","title":"DockerEngineAPI.Model.HostConfigAllOfLogConfig.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.HostConfigAllOfLogConfig.html#t:t/0","title":"DockerEngineAPI.Model.HostConfigAllOfLogConfig.t/0","type":"type"},{"doc":"Response to an API call that returns just an Id","ref":"DockerEngineAPI.Model.IdResponse.html","title":"DockerEngineAPI.Model.IdResponse","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.IdResponse.html#decode/1","title":"DockerEngineAPI.Model.IdResponse.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.IdResponse.html#t:t/0","title":"DockerEngineAPI.Model.IdResponse.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.ImageDeleteResponseItem.html","title":"DockerEngineAPI.Model.ImageDeleteResponseItem","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ImageDeleteResponseItem.html#decode/1","title":"DockerEngineAPI.Model.ImageDeleteResponseItem.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ImageDeleteResponseItem.html#t:t/0","title":"DockerEngineAPI.Model.ImageDeleteResponseItem.t/0","type":"type"},{"doc":"Image ID or Digest","ref":"DockerEngineAPI.Model.ImageId.html","title":"DockerEngineAPI.Model.ImageId","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ImageId.html#decode/1","title":"DockerEngineAPI.Model.ImageId.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ImageId.html#t:t/0","title":"DockerEngineAPI.Model.ImageId.t/0","type":"type"},{"doc":"Information about an image in the local image cache.","ref":"DockerEngineAPI.Model.ImageInspect.html","title":"DockerEngineAPI.Model.ImageInspect","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ImageInspect.html#decode/1","title":"DockerEngineAPI.Model.ImageInspect.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ImageInspect.html#t:t/0","title":"DockerEngineAPI.Model.ImageInspect.t/0","type":"type"},{"doc":"Additional metadata of the image in the local cache. This information is local to the daemon, and not part of the image itself.","ref":"DockerEngineAPI.Model.ImageInspectMetadata.html","title":"DockerEngineAPI.Model.ImageInspectMetadata","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ImageInspectMetadata.html#decode/1","title":"DockerEngineAPI.Model.ImageInspectMetadata.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ImageInspectMetadata.html#t:t/0","title":"DockerEngineAPI.Model.ImageInspectMetadata.t/0","type":"type"},{"doc":"Information about the image's RootFS, including the layer IDs.","ref":"DockerEngineAPI.Model.ImageInspectRootFs.html","title":"DockerEngineAPI.Model.ImageInspectRootFs","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ImageInspectRootFs.html#decode/1","title":"DockerEngineAPI.Model.ImageInspectRootFs.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ImageInspectRootFs.html#t:t/0","title":"DockerEngineAPI.Model.ImageInspectRootFs.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.ImagePruneResponse.html","title":"DockerEngineAPI.Model.ImagePruneResponse","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ImagePruneResponse.html#decode/1","title":"DockerEngineAPI.Model.ImagePruneResponse.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ImagePruneResponse.html#t:t/0","title":"DockerEngineAPI.Model.ImagePruneResponse.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.ImageSearchResponseItem.html","title":"DockerEngineAPI.Model.ImageSearchResponseItem","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ImageSearchResponseItem.html#decode/1","title":"DockerEngineAPI.Model.ImageSearchResponseItem.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ImageSearchResponseItem.html#t:t/0","title":"DockerEngineAPI.Model.ImageSearchResponseItem.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.ImageSummary.html","title":"DockerEngineAPI.Model.ImageSummary","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ImageSummary.html#decode/1","title":"DockerEngineAPI.Model.ImageSummary.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ImageSummary.html#t:t/0","title":"DockerEngineAPI.Model.ImageSummary.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.Ipam.html","title":"DockerEngineAPI.Model.Ipam","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.Ipam.html#decode/1","title":"DockerEngineAPI.Model.Ipam.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.Ipam.html#t:t/0","title":"DockerEngineAPI.Model.Ipam.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.IpamConfig.html","title":"DockerEngineAPI.Model.IpamConfig","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.IpamConfig.html#decode/1","title":"DockerEngineAPI.Model.IpamConfig.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.IpamConfig.html#t:t/0","title":"DockerEngineAPI.Model.IpamConfig.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.Mount.html","title":"DockerEngineAPI.Model.Mount","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.Mount.html#decode/1","title":"DockerEngineAPI.Model.Mount.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.Mount.html#t:t/0","title":"DockerEngineAPI.Model.Mount.t/0","type":"type"},{"doc":"Optional configuration for the `bind` type.","ref":"DockerEngineAPI.Model.MountBindOptions.html","title":"DockerEngineAPI.Model.MountBindOptions","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.MountBindOptions.html#decode/1","title":"DockerEngineAPI.Model.MountBindOptions.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.MountBindOptions.html#t:t/0","title":"DockerEngineAPI.Model.MountBindOptions.t/0","type":"type"},{"doc":"MountPoint represents a mount point configuration inside the container. This is used for reporting the mountpoints in use by a container.","ref":"DockerEngineAPI.Model.MountPoint.html","title":"DockerEngineAPI.Model.MountPoint","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.MountPoint.html#decode/1","title":"DockerEngineAPI.Model.MountPoint.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.MountPoint.html#t:t/0","title":"DockerEngineAPI.Model.MountPoint.t/0","type":"type"},{"doc":"Optional configuration for the `tmpfs` type.","ref":"DockerEngineAPI.Model.MountTmpfsOptions.html","title":"DockerEngineAPI.Model.MountTmpfsOptions","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.MountTmpfsOptions.html#decode/1","title":"DockerEngineAPI.Model.MountTmpfsOptions.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.MountTmpfsOptions.html#t:t/0","title":"DockerEngineAPI.Model.MountTmpfsOptions.t/0","type":"type"},{"doc":"Optional configuration for the `volume` type.","ref":"DockerEngineAPI.Model.MountVolumeOptions.html","title":"DockerEngineAPI.Model.MountVolumeOptions","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.MountVolumeOptions.html#decode/1","title":"DockerEngineAPI.Model.MountVolumeOptions.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.MountVolumeOptions.html#t:t/0","title":"DockerEngineAPI.Model.MountVolumeOptions.t/0","type":"type"},{"doc":"Map of driver specific options","ref":"DockerEngineAPI.Model.MountVolumeOptionsDriverConfig.html","title":"DockerEngineAPI.Model.MountVolumeOptionsDriverConfig","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.MountVolumeOptionsDriverConfig.html#decode/1","title":"DockerEngineAPI.Model.MountVolumeOptionsDriverConfig.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.MountVolumeOptionsDriverConfig.html#t:t/0","title":"DockerEngineAPI.Model.MountVolumeOptionsDriverConfig.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.Network.html","title":"DockerEngineAPI.Model.Network","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.Network.html#decode/1","title":"DockerEngineAPI.Model.Network.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.Network.html#t:t/0","title":"DockerEngineAPI.Model.Network.t/0","type":"type"},{"doc":"Specifies how a service should be attached to a particular network.","ref":"DockerEngineAPI.Model.NetworkAttachmentConfig.html","title":"DockerEngineAPI.Model.NetworkAttachmentConfig","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.NetworkAttachmentConfig.html#decode/1","title":"DockerEngineAPI.Model.NetworkAttachmentConfig.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.NetworkAttachmentConfig.html#t:t/0","title":"DockerEngineAPI.Model.NetworkAttachmentConfig.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.NetworkConnectRequest.html","title":"DockerEngineAPI.Model.NetworkConnectRequest","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.NetworkConnectRequest.html#decode/1","title":"DockerEngineAPI.Model.NetworkConnectRequest.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.NetworkConnectRequest.html#t:t/0","title":"DockerEngineAPI.Model.NetworkConnectRequest.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.NetworkContainer.html","title":"DockerEngineAPI.Model.NetworkContainer","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.NetworkContainer.html#decode/1","title":"DockerEngineAPI.Model.NetworkContainer.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.NetworkContainer.html#t:t/0","title":"DockerEngineAPI.Model.NetworkContainer.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.NetworkCreateRequest.html","title":"DockerEngineAPI.Model.NetworkCreateRequest","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.NetworkCreateRequest.html#decode/1","title":"DockerEngineAPI.Model.NetworkCreateRequest.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.NetworkCreateRequest.html#t:t/0","title":"DockerEngineAPI.Model.NetworkCreateRequest.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.NetworkCreateResponse.html","title":"DockerEngineAPI.Model.NetworkCreateResponse","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.NetworkCreateResponse.html#decode/1","title":"DockerEngineAPI.Model.NetworkCreateResponse.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.NetworkCreateResponse.html#t:t/0","title":"DockerEngineAPI.Model.NetworkCreateResponse.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.NetworkDisconnectRequest.html","title":"DockerEngineAPI.Model.NetworkDisconnectRequest","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.NetworkDisconnectRequest.html#decode/1","title":"DockerEngineAPI.Model.NetworkDisconnectRequest.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.NetworkDisconnectRequest.html#t:t/0","title":"DockerEngineAPI.Model.NetworkDisconnectRequest.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.NetworkPruneResponse.html","title":"DockerEngineAPI.Model.NetworkPruneResponse","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.NetworkPruneResponse.html#decode/1","title":"DockerEngineAPI.Model.NetworkPruneResponse.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.NetworkPruneResponse.html#t:t/0","title":"DockerEngineAPI.Model.NetworkPruneResponse.t/0","type":"type"},{"doc":"NetworkSettings exposes the network settings in the API","ref":"DockerEngineAPI.Model.NetworkSettings.html","title":"DockerEngineAPI.Model.NetworkSettings","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.NetworkSettings.html#decode/1","title":"DockerEngineAPI.Model.NetworkSettings.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.NetworkSettings.html#t:t/0","title":"DockerEngineAPI.Model.NetworkSettings.t/0","type":"type"},{"doc":"NetworkingConfig represents the container's networking configuration for each of its interfaces. It is used for the networking configs specified in the `docker create` and `docker network connect` commands.","ref":"DockerEngineAPI.Model.NetworkingConfig.html","title":"DockerEngineAPI.Model.NetworkingConfig","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.NetworkingConfig.html#decode/1","title":"DockerEngineAPI.Model.NetworkingConfig.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.NetworkingConfig.html#t:t/0","title":"DockerEngineAPI.Model.NetworkingConfig.t/0","type":"type"},{"doc":"An open port on a container","ref":"DockerEngineAPI.Model.Port.html","title":"DockerEngineAPI.Model.Port","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.Port.html#decode/1","title":"DockerEngineAPI.Model.Port.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.Port.html#t:t/0","title":"DockerEngineAPI.Model.Port.t/0","type":"type"},{"doc":"PortBinding represents a binding between a host IP address and a host port.","ref":"DockerEngineAPI.Model.PortBinding.html","title":"DockerEngineAPI.Model.PortBinding","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.PortBinding.html#decode/1","title":"DockerEngineAPI.Model.PortBinding.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.PortBinding.html#t:t/0","title":"DockerEngineAPI.Model.PortBinding.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.ProcessConfig.html","title":"DockerEngineAPI.Model.ProcessConfig","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ProcessConfig.html#decode/1","title":"DockerEngineAPI.Model.ProcessConfig.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ProcessConfig.html#t:t/0","title":"DockerEngineAPI.Model.ProcessConfig.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.ProgressDetail.html","title":"DockerEngineAPI.Model.ProgressDetail","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ProgressDetail.html#decode/1","title":"DockerEngineAPI.Model.ProgressDetail.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ProgressDetail.html#t:t/0","title":"DockerEngineAPI.Model.ProgressDetail.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.ResourcesBlkioWeightDeviceInner.html","title":"DockerEngineAPI.Model.ResourcesBlkioWeightDeviceInner","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ResourcesBlkioWeightDeviceInner.html#decode/1","title":"DockerEngineAPI.Model.ResourcesBlkioWeightDeviceInner.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ResourcesBlkioWeightDeviceInner.html#t:t/0","title":"DockerEngineAPI.Model.ResourcesBlkioWeightDeviceInner.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.ResourcesUlimitsInner.html","title":"DockerEngineAPI.Model.ResourcesUlimitsInner","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ResourcesUlimitsInner.html#decode/1","title":"DockerEngineAPI.Model.ResourcesUlimitsInner.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ResourcesUlimitsInner.html#t:t/0","title":"DockerEngineAPI.Model.ResourcesUlimitsInner.t/0","type":"type"},{"doc":"The behavior to apply when the container exits. The default is not to restart.  An ever increasing delay (double the previous delay, starting at 100ms) is added before each restart to prevent flooding the server.","ref":"DockerEngineAPI.Model.RestartPolicy.html","title":"DockerEngineAPI.Model.RestartPolicy","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.RestartPolicy.html#decode/1","title":"DockerEngineAPI.Model.RestartPolicy.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.RestartPolicy.html#t:t/0","title":"DockerEngineAPI.Model.RestartPolicy.t/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.Model.ThrottleDevice.html","title":"DockerEngineAPI.Model.ThrottleDevice","type":"module"},{"doc":"","ref":"DockerEngineAPI.Model.ThrottleDevice.html#decode/1","title":"DockerEngineAPI.Model.ThrottleDevice.decode/1","type":"function"},{"doc":"","ref":"DockerEngineAPI.Model.ThrottleDevice.html#t:t/0","title":"DockerEngineAPI.Model.ThrottleDevice.t/0","type":"type"},{"doc":"Helper functions for building Tesla requests","ref":"DockerEngineAPI.RequestBuilder.html","title":"DockerEngineAPI.RequestBuilder","type":"module"},{"doc":"Add optional parameters to the request.","ref":"DockerEngineAPI.RequestBuilder.html#add_optional_params/3","title":"DockerEngineAPI.RequestBuilder.add_optional_params/3","type":"function"},{"doc":"- `request` (Map) - Collected request options\n- `definitions` (Map) - Map of parameter name to parameter location.\n- `options` (KeywordList) - The provided optional parameters","ref":"DockerEngineAPI.RequestBuilder.html#add_optional_params/3-parameters","title":"Parameters - DockerEngineAPI.RequestBuilder.add_optional_params/3","type":"function"},{"doc":"Map","ref":"DockerEngineAPI.RequestBuilder.html#add_optional_params/3-returns","title":"Returns - DockerEngineAPI.RequestBuilder.add_optional_params/3","type":"function"},{"doc":"Add non-optional parameters to the request.","ref":"DockerEngineAPI.RequestBuilder.html#add_param/4","title":"DockerEngineAPI.RequestBuilder.add_param/4","type":"function"},{"doc":"- `request` (Map) - Collected request options\n- `location` (atom) - Where to put the parameter\n- `key` (atom) - The name of the parameter\n- `value` (any) - The value of the parameter","ref":"DockerEngineAPI.RequestBuilder.html#add_param/4-parameters","title":"Parameters - DockerEngineAPI.RequestBuilder.add_param/4","type":"function"},{"doc":"Map","ref":"DockerEngineAPI.RequestBuilder.html#add_param/4-returns","title":"Returns - DockerEngineAPI.RequestBuilder.add_param/4","type":"function"},{"doc":"This function ensures that the `body` parameter is always set.\n\nWhen using Tesla with the `httpc` adapter (the default adapter), there is a\nbug where POST, PATCH and PUT requests will fail if the body is empty.","ref":"DockerEngineAPI.RequestBuilder.html#ensure_body/1","title":"DockerEngineAPI.RequestBuilder.ensure_body/1","type":"function"},{"doc":"- `request` (Map) - Collected request options","ref":"DockerEngineAPI.RequestBuilder.html#ensure_body/1-parameters","title":"Parameters - DockerEngineAPI.RequestBuilder.ensure_body/1","type":"function"},{"doc":"Map","ref":"DockerEngineAPI.RequestBuilder.html#ensure_body/1-returns","title":"Returns - DockerEngineAPI.RequestBuilder.ensure_body/1","type":"function"},{"doc":"Evaluate and decode the response from a Tesla request.\n\n- `result` (Tesla.Env.result()): The Tesla response.\n- `mapping` ([{http_status, struct}]): Status-to-struct mapping for decoding.","ref":"DockerEngineAPI.RequestBuilder.html#evaluate_response/2","title":"DockerEngineAPI.RequestBuilder.evaluate_response/2","type":"function"},{"doc":"Specify the request `method` when building a request.\n\nDoes not override the `method` if one has already been specified.","ref":"DockerEngineAPI.RequestBuilder.html#method/2","title":"DockerEngineAPI.RequestBuilder.method/2","type":"function"},{"doc":"- `request` (Map) - Collected request options\n- `method` (atom) - Request method","ref":"DockerEngineAPI.RequestBuilder.html#method/2-parameters","title":"Parameters - DockerEngineAPI.RequestBuilder.method/2","type":"function"},{"doc":"Map","ref":"DockerEngineAPI.RequestBuilder.html#method/2-returns","title":"Returns - DockerEngineAPI.RequestBuilder.method/2","type":"function"},{"doc":"Specify the request URL when building a request.\n\nDoes not override the `url` if one has already been specified.","ref":"DockerEngineAPI.RequestBuilder.html#url/2","title":"DockerEngineAPI.RequestBuilder.url/2","type":"function"},{"doc":"- `request` (Map) - Collected request options\n- `url` (String) - Request URL","ref":"DockerEngineAPI.RequestBuilder.html#url/2-parameters","title":"Parameters - DockerEngineAPI.RequestBuilder.url/2","type":"function"},{"doc":"Map","ref":"DockerEngineAPI.RequestBuilder.html#url/2-returns","title":"Returns - DockerEngineAPI.RequestBuilder.url/2","type":"function"},{"doc":"","ref":"DockerEngineAPI.RequestBuilder.html#t:response_mapping/0","title":"DockerEngineAPI.RequestBuilder.response_mapping/0","type":"type"},{"doc":"","ref":"DockerEngineAPI.RequestBuilder.html#t:status_code/0","title":"DockerEngineAPI.RequestBuilder.status_code/0","type":"type"},{"doc":"","ref":"Mix.Tasks.Testcontainers.Test.html","title":"mix testcontainers.test","type":"task"},{"doc":"","ref":"Mix.Tasks.Testcontainers.Test.html#run/1","title":"Mix.Tasks.Testcontainers.Test.run/1","type":"function"},{"doc":"The main entry point into Testcontainers.\n\nThis is a GenServer that needs to be started before anything can happen.","ref":"Testcontainers.html","title":"Testcontainers","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Testcontainers.html#child_spec/1","title":"Testcontainers.child_spec/1","type":"function"},{"doc":"Starts a new container based on the provided configuration, applying any specified wait strategies.\n\nThis function performs several steps:\n1. Pulls the necessary Docker image.\n2. Creates and starts a container with the specified configuration.\n3. Registers the container with a reaper process for automatic cleanup, ensuring it is stopped and removed when the current process exits or in case of unforeseen failures.","ref":"Testcontainers.html#start_container/2","title":"Testcontainers.start_container/2","type":"function"},{"doc":"- `config`: A `%Container{}` struct containing the configuration settings for the container, such as the image to use, environment variables, bound ports, and volume bindings.","ref":"Testcontainers.html#start_container/2-parameters","title":"Parameters - Testcontainers.start_container/2","type":"function"},{"doc":"iex> config = Testcontainers.MySqlContainer.new()\n    iex> {:ok, container} = Testcontainers.start_container(config)","ref":"Testcontainers.html#start_container/2-examples","title":"Examples - Testcontainers.start_container/2","type":"function"},{"doc":"- `{:ok, container}` if the container is successfully created, started, and passes all wait strategies.\n- An error tuple, such as `{:error, reason}`, if there is a failure at any step in the process.","ref":"Testcontainers.html#start_container/2-returns","title":"Returns - Testcontainers.start_container/2","type":"function"},{"doc":"- The container is automatically registered with a reaper process, ensuring it is stopped and removed when the current process exits, or in the case of unforeseen failures.\n- It's important to specify appropriate wait strategies to ensure the container is fully ready for interaction, especially for containers that may take some time to start up services internally.","ref":"Testcontainers.html#start_container/2-notes","title":"Notes - Testcontainers.start_container/2","type":"function"},{"doc":"","ref":"Testcontainers.html#start_link/1","title":"Testcontainers.start_link/1","type":"function"},{"doc":"Stops a running container.\n\nThis sends a stop command to the specified container. The Docker daemon terminates the container process gracefully.","ref":"Testcontainers.html#stop_container/2","title":"Testcontainers.stop_container/2","type":"function"},{"doc":"- `container_id`: The ID of the container to stop, as a string.","ref":"Testcontainers.html#stop_container/2-parameters","title":"Parameters - Testcontainers.stop_container/2","type":"function"},{"doc":"- `:ok` if the container stops successfully.\n- `{:error, reason}` on failure.","ref":"Testcontainers.html#stop_container/2-returns","title":"Returns - Testcontainers.stop_container/2","type":"function"},{"doc":":ok = Testcontainers.Connection.stop_container(\"my_container_id\")","ref":"Testcontainers.html#stop_container/2-examples","title":"Examples - Testcontainers.stop_container/2","type":"function"},{"doc":"Provides functionality for creating and managing Cassandra container configurations.","ref":"Testcontainers.CassandraContainer.html","title":"Testcontainers.CassandraContainer","type":"module"},{"doc":"Generates the connection URL for accessing the Cassandra service running within the container.","ref":"Testcontainers.CassandraContainer.html#connection_uri/1","title":"Testcontainers.CassandraContainer.connection_uri/1","type":"function"},{"doc":"","ref":"Testcontainers.CassandraContainer.html#default_image/0","title":"Testcontainers.CassandraContainer.default_image/0","type":"function"},{"doc":"","ref":"Testcontainers.CassandraContainer.html#default_port/0","title":"Testcontainers.CassandraContainer.default_port/0","type":"function"},{"doc":"","ref":"Testcontainers.CassandraContainer.html#get_password/0","title":"Testcontainers.CassandraContainer.get_password/0","type":"function"},{"doc":"","ref":"Testcontainers.CassandraContainer.html#get_username/0","title":"Testcontainers.CassandraContainer.get_username/0","type":"function"},{"doc":"","ref":"Testcontainers.CassandraContainer.html#new/0","title":"Testcontainers.CassandraContainer.new/0","type":"function"},{"doc":"Retrieves the port mapped by the Docker host for the Cassandra container.","ref":"Testcontainers.CassandraContainer.html#port/1","title":"Testcontainers.CassandraContainer.port/1","type":"function"},{"doc":"Set the regular expression to check the image validity.","ref":"Testcontainers.CassandraContainer.html#with_check_image/2","title":"Testcontainers.CassandraContainer.with_check_image/2","type":"function"},{"doc":"","ref":"Testcontainers.CassandraContainer.html#with_image/2","title":"Testcontainers.CassandraContainer.with_image/2","type":"function"},{"doc":"Set the reuse flag to reuse the container if it is already running.","ref":"Testcontainers.CassandraContainer.html#with_reuse/2","title":"Testcontainers.CassandraContainer.with_reuse/2","type":"function"},{"doc":"Provides functionality for creating and managing Ceph container configurations.","ref":"Testcontainers.CephContainer.html","title":"Testcontainers.CephContainer","type":"module"},{"doc":"Generates the connection options for accessing the Ceph service running within the container.\nCompatible with what ex_aws expects in `ExAws.request(options)`","ref":"Testcontainers.CephContainer.html#connection_opts/1","title":"Testcontainers.CephContainer.connection_opts/1","type":"function"},{"doc":"Generates the connection URL for accessing the Ceph service running within the container.\n\nThis URL is based on the standard localhost IP and the mapped port for the container.","ref":"Testcontainers.CephContainer.html#connection_url/1","title":"Testcontainers.CephContainer.connection_url/1","type":"function"},{"doc":"- `container`: The active Ceph container instance.","ref":"Testcontainers.CephContainer.html#connection_url/1-parameters","title":"Parameters - Testcontainers.CephContainer.connection_url/1","type":"function"},{"doc":"iex> CephContainer.connection_url(container)\n    \"http://localhost:32768\" # This value will be different depending on the mapped port.","ref":"Testcontainers.CephContainer.html#connection_url/1-examples","title":"Examples - Testcontainers.CephContainer.connection_url/1","type":"function"},{"doc":"Retrieves the default Docker image used for the Ceph container.","ref":"Testcontainers.CephContainer.html#default_image/0","title":"Testcontainers.CephContainer.default_image/0","type":"function"},{"doc":"iex> CephContainer.default_image()\n    \"quay.io/ceph/demo\"","ref":"Testcontainers.CephContainer.html#default_image/0-examples","title":"Examples - Testcontainers.CephContainer.default_image/0","type":"function"},{"doc":"Creates a new `CephContainer` struct with default attributes.","ref":"Testcontainers.CephContainer.html#new/0","title":"Testcontainers.CephContainer.new/0","type":"function"},{"doc":"Retrieves the port mapped by the Docker host for the Ceph container.","ref":"Testcontainers.CephContainer.html#port/1","title":"Testcontainers.CephContainer.port/1","type":"function"},{"doc":"- `container`: The active Ceph container instance.","ref":"Testcontainers.CephContainer.html#port/1-parameters","title":"Parameters - Testcontainers.CephContainer.port/1","type":"function"},{"doc":"iex> CephContainer.port(container)\n    32768 # This value will be different depending on the mapped port.","ref":"Testcontainers.CephContainer.html#port/1-examples","title":"Examples - Testcontainers.CephContainer.port/1","type":"function"},{"doc":"Sets the `access_key` used for authentication with the Ceph container.","ref":"Testcontainers.CephContainer.html#with_access_key/2","title":"Testcontainers.CephContainer.with_access_key/2","type":"function"},{"doc":"iex> config = CephContainer.new()\n    iex> new_config = CephContainer.with_access_key(config, \"new_access_key\")\n    iex> new_config.access_key\n    \"new_access_key\"","ref":"Testcontainers.CephContainer.html#with_access_key/2-examples","title":"Examples - Testcontainers.CephContainer.with_access_key/2","type":"function"},{"doc":"Sets the `bucket` that is automatically in the Ceph container.","ref":"Testcontainers.CephContainer.html#with_bucket/2","title":"Testcontainers.CephContainer.with_bucket/2","type":"function"},{"doc":"iex> config = CephContainer.new()\n    iex> new_config = CephContainer.with_bucket(config, \"test_bucket\")\n    iex> new_config.bucket\n    \"test_bucket\"","ref":"Testcontainers.CephContainer.html#with_bucket/2-examples","title":"Examples - Testcontainers.CephContainer.with_bucket/2","type":"function"},{"doc":"Set the regular expression to check the image validity.","ref":"Testcontainers.CephContainer.html#with_check_image/2","title":"Testcontainers.CephContainer.with_check_image/2","type":"function"},{"doc":"Sets the `image` of the Ceph container configuration.","ref":"Testcontainers.CephContainer.html#with_image/2","title":"Testcontainers.CephContainer.with_image/2","type":"function"},{"doc":"iex> config = CephContainer.new()\n    iex> new_config = CephContainer.with_image(config, \"quay.io/ceph/alternative\")\n    iex> new_config.image\n    \"quay.io/ceph/alternative\"","ref":"Testcontainers.CephContainer.html#with_image/2-examples","title":"Examples - Testcontainers.CephContainer.with_image/2","type":"function"},{"doc":"Sets the port on which the Ceph container will be exposed.","ref":"Testcontainers.CephContainer.html#with_port/2","title":"Testcontainers.CephContainer.with_port/2","type":"function"},{"doc":"- `config`: The current Ceph container configuration.\n- `port`: The target port number.","ref":"Testcontainers.CephContainer.html#with_port/2-parameters","title":"Parameters - Testcontainers.CephContainer.with_port/2","type":"function"},{"doc":"iex> config = CephContainer.new()\n    iex> new_config = CephContainer.with_port(config, 8081)\n    iex> new_config.port\n    8081","ref":"Testcontainers.CephContainer.html#with_port/2-examples","title":"Examples - Testcontainers.CephContainer.with_port/2","type":"function"},{"doc":"Set the reuse flag to reuse the container if it is already running.","ref":"Testcontainers.CephContainer.html#with_reuse/2","title":"Testcontainers.CephContainer.with_reuse/2","type":"function"},{"doc":"Sets the `secret_key` used for authentication with the Ceph container.","ref":"Testcontainers.CephContainer.html#with_secret_key/2","title":"Testcontainers.CephContainer.with_secret_key/2","type":"function"},{"doc":"iex> config = CephContainer.new()\n    iex> new_config = CephContainer.with_secret_key(config, \"new_secret_key\")\n    iex> new_config.secret_key\n    \"new_secret_key\"","ref":"Testcontainers.CephContainer.html#with_secret_key/2-examples","title":"Examples - Testcontainers.CephContainer.with_secret_key/2","type":"function"},{"doc":"Sets the maximum time (in milliseconds) the system will wait for the Ceph container to be ready before timing out.","ref":"Testcontainers.CephContainer.html#with_wait_timeout/2","title":"Testcontainers.CephContainer.with_wait_timeout/2","type":"function"},{"doc":"- `config`: The current Ceph container configuration.\n- `wait_timeout`: The time to wait in milliseconds.","ref":"Testcontainers.CephContainer.html#with_wait_timeout/2-parameters","title":"Parameters - Testcontainers.CephContainer.with_wait_timeout/2","type":"function"},{"doc":"iex> config = CephContainer.new()\n    iex> new_config = CephContainer.with_wait_timeout(config, 400_000)\n    iex> new_config.wait_timeout\n    400_000","ref":"Testcontainers.CephContainer.html#with_wait_timeout/2-examples","title":"Examples - Testcontainers.CephContainer.with_wait_timeout/2","type":"function"},{"doc":"Considers a container ready as soon as a command runs successfully inside it.","ref":"Testcontainers.CommandWaitStrategy.html","title":"Testcontainers.CommandWaitStrategy","type":"module"},{"doc":"Creates a new CommandWaitStrategy.\nThis strategy waits until the given command executes successfully inside the container.","ref":"Testcontainers.CommandWaitStrategy.html#new/3","title":"Testcontainers.CommandWaitStrategy.new/3","type":"function"},{"doc":"A struct with builder functions for creating a definition of a container.","ref":"Testcontainers.Container.html","title":"Testcontainers.Container","type":"module"},{"doc":"","ref":"Testcontainers.Container.html#is_os/1","title":"Testcontainers.Container.is_os/1","type":"macro"},{"doc":"Returns `true` if `term` is a valid `check_image`, otherwise returns `false`.","ref":"Testcontainers.Container.html#is_valid_image/1","title":"Testcontainers.Container.is_valid_image/1","type":"macro"},{"doc":"Gets the host port on the container for the given exposed port.","ref":"Testcontainers.Container.html#mapped_port/2","title":"Testcontainers.Container.mapped_port/2","type":"function"},{"doc":"A constructor function to make it easier to construct a container","ref":"Testcontainers.Container.html#new/1","title":"Testcontainers.Container.new/1","type":"function"},{"doc":"Check if the provided image is compatible with the expected default image.","ref":"Testcontainers.Container.html#valid_image/1","title":"Testcontainers.Container.valid_image/1","type":"function"},{"doc":"Check if the provided image is compatible with the expected default image.\n\nRaises:\n\nArgumentError when image isn't compatible.","ref":"Testcontainers.Container.html#valid_image!/1","title":"Testcontainers.Container.valid_image!/1","type":"function"},{"doc":"Adds authentication token for registries that require a login.","ref":"Testcontainers.Container.html#with_auth/3","title":"Testcontainers.Container.with_auth/3","type":"function"},{"doc":"Sets whether the container should be automatically removed on exit.","ref":"Testcontainers.Container.html#with_auto_remove/2","title":"Testcontainers.Container.with_auto_remove/2","type":"function"},{"doc":"Sets a file or the directory on the _host machine_ to be mounted into a _container_.","ref":"Testcontainers.Container.html#with_bind_mount/4","title":"Testcontainers.Container.with_bind_mount/4","type":"function"},{"doc":"Sets a volume to be mounted into a container on target path","ref":"Testcontainers.Container.html#with_bind_volume/4","title":"Testcontainers.Container.with_bind_volume/4","type":"function"},{"doc":"Set the regular expression to check the image validity.\n\nWhen using a string, it will compile it to a regular expression. If the compilation fails, it will raise a `Regex.CompileError`.","ref":"Testcontainers.Container.html#with_check_image/2","title":"Testcontainers.Container.with_check_image/2","type":"function"},{"doc":"Sets a cmd to run when the container starts.","ref":"Testcontainers.Container.html#with_cmd/2","title":"Testcontainers.Container.with_cmd/2","type":"function"},{"doc":"Sets an _environment variable_ to the _container_.","ref":"Testcontainers.Container.html#with_environment/3","title":"Testcontainers.Container.with_environment/3","type":"function"},{"doc":"Adds a _port_ to be exposed on the _container_.","ref":"Testcontainers.Container.html#with_exposed_port/2","title":"Testcontainers.Container.with_exposed_port/2","type":"function"},{"doc":"Adds multiple _ports_ to be exposed on the _container_.","ref":"Testcontainers.Container.html#with_exposed_ports/2","title":"Testcontainers.Container.with_exposed_ports/2","type":"function"},{"doc":"Adds a fixed _port_ to be exposed on the _container_.\nThis approach to managing ports is not recommended by Testcontainers.\nUse at your own risk.","ref":"Testcontainers.Container.html#with_fixed_port/3","title":"Testcontainers.Container.with_fixed_port/3","type":"function"},{"doc":"","ref":"Testcontainers.Container.html#with_force_reuse/2","title":"Testcontainers.Container.with_force_reuse/2","type":"function"},{"doc":"Sets a label to apply to the container object in docker.","ref":"Testcontainers.Container.html#with_label/3","title":"Testcontainers.Container.with_label/3","type":"function"},{"doc":"Sets a network mode to apply to the container object in docker.","ref":"Testcontainers.Container.html#with_network_mode/2","title":"Testcontainers.Container.with_network_mode/2","type":"function"},{"doc":"Sets whether the container should be reused if it is already running.","ref":"Testcontainers.Container.html#with_reuse/2","title":"Testcontainers.Container.with_reuse/2","type":"function"},{"doc":"Sets multiple _waiting strategies_ for the _container_.","ref":"Testcontainers.Container.html#with_waiting_strategies/2","title":"Testcontainers.Container.with_waiting_strategies/2","type":"function"},{"doc":"Sets a _waiting strategy_ for the _container_.","ref":"Testcontainers.Container.html#with_waiting_strategy/2","title":"Testcontainers.Container.with_waiting_strategy/2","type":"function"},{"doc":"All types of predefined containers must implement this protocol.","ref":"Testcontainers.ContainerBuilder.html","title":"Testcontainers.ContainerBuilder","type":"protocol"},{"doc":"Do stuff after container has started.","ref":"Testcontainers.ContainerBuilder.html#after_start/3","title":"Testcontainers.ContainerBuilder.after_start/3","type":"function"},{"doc":"","ref":"Testcontainers.ContainerBuilder.html#build/1","title":"Testcontainers.ContainerBuilder.build/1","type":"function"},{"doc":"","ref":"Testcontainers.ContainerBuilder.html#t:t/0","title":"Testcontainers.ContainerBuilder.t/0","type":"type"},{"doc":"","ref":"Testcontainers.ContainerBuilderHelper.html","title":"Testcontainers.ContainerBuilderHelper","type":"module"},{"doc":"","ref":"Testcontainers.ContainerBuilderHelper.html#build/2","title":"Testcontainers.ContainerBuilderHelper.build/2","type":"function"},{"doc":"A behaviour implemented by database containers used by `Testcontainers.Ecto`","ref":"Testcontainers.DatabaseBehaviour.html","title":"Testcontainers.DatabaseBehaviour","type":"behaviour"},{"doc":"","ref":"Testcontainers.DatabaseBehaviour.html#c:new/0","title":"Testcontainers.DatabaseBehaviour.new/0","type":"callback"},{"doc":"","ref":"Testcontainers.DatabaseBehaviour.html#c:with_database/2","title":"Testcontainers.DatabaseBehaviour.with_database/2","type":"callback"},{"doc":"","ref":"Testcontainers.DatabaseBehaviour.html#c:with_image/2","title":"Testcontainers.DatabaseBehaviour.with_image/2","type":"callback"},{"doc":"","ref":"Testcontainers.DatabaseBehaviour.html#c:with_password/2","title":"Testcontainers.DatabaseBehaviour.with_password/2","type":"callback"},{"doc":"","ref":"Testcontainers.DatabaseBehaviour.html#c:with_persistent_volume/2","title":"Testcontainers.DatabaseBehaviour.with_persistent_volume/2","type":"callback"},{"doc":"","ref":"Testcontainers.DatabaseBehaviour.html#c:with_port/2","title":"Testcontainers.DatabaseBehaviour.with_port/2","type":"callback"},{"doc":"","ref":"Testcontainers.DatabaseBehaviour.html#c:with_user/2","title":"Testcontainers.DatabaseBehaviour.with_user/2","type":"callback"},{"doc":"","ref":"Testcontainers.DatabaseBehaviour.html#t:t/0","title":"Testcontainers.DatabaseBehaviour.t/0","type":"type"},{"doc":"Internal docker api. Only for direct use by `Testcontainers`","ref":"Testcontainers.Docker.Api.html","title":"Testcontainers.Docker.Api","type":"module"},{"doc":"","ref":"Testcontainers.Docker.Api.html#create_container/2","title":"Testcontainers.Docker.Api.create_container/2","type":"function"},{"doc":"","ref":"Testcontainers.Docker.Api.html#get_bridge_gateway/1","title":"Testcontainers.Docker.Api.get_bridge_gateway/1","type":"function"},{"doc":"","ref":"Testcontainers.Docker.Api.html#get_container/2","title":"Testcontainers.Docker.Api.get_container/2","type":"function"},{"doc":"","ref":"Testcontainers.Docker.Api.html#get_container_by_hash/2","title":"Testcontainers.Docker.Api.get_container_by_hash/2","type":"function"},{"doc":"","ref":"Testcontainers.Docker.Api.html#inspect_exec/2","title":"Testcontainers.Docker.Api.inspect_exec/2","type":"function"},{"doc":"","ref":"Testcontainers.Docker.Api.html#pull_image/3","title":"Testcontainers.Docker.Api.pull_image/3","type":"function"},{"doc":"","ref":"Testcontainers.Docker.Api.html#put_file/5","title":"Testcontainers.Docker.Api.put_file/5","type":"function"},{"doc":"","ref":"Testcontainers.Docker.Api.html#start_container/2","title":"Testcontainers.Docker.Api.start_container/2","type":"function"},{"doc":"","ref":"Testcontainers.Docker.Api.html#start_exec/3","title":"Testcontainers.Docker.Api.start_exec/3","type":"function"},{"doc":"","ref":"Testcontainers.Docker.Api.html#stdout_logs/2","title":"Testcontainers.Docker.Api.stdout_logs/2","type":"function"},{"doc":"","ref":"Testcontainers.Docker.Api.html#stop_container/2","title":"Testcontainers.Docker.Api.stop_container/2","type":"function"},{"doc":"Facilitates the creation of a Postgres or MySql container for testing with Ecto.\n\nThis module simplifies the process of launching a real Postgres or MySql database instance within a Docker container for testing purposes. It leverages the `Testcontainers` library to instantiate a Postgres or MySql container with the desired configuration, providing an isolated database environment for each test session.","ref":"Testcontainers.Ecto.html","title":"Testcontainers.Ecto","type":"module"},{"doc":"Initiates a new Mysql instance, executes migrations, and prepares a suitable database environment, specifically tailored for testing scenarios.","ref":"Testcontainers.Ecto.html#mysql_container/1","title":"Testcontainers.Ecto.mysql_container/1","type":"function"},{"doc":"- `options`: Configurations for the Mysql container, provided as a keyword list. The only required option is `:app`. Other options include:\n  - `:app` - The current application's atom, necessary for building paths and other application-specific logic. This is a required parameter.\n  - `:repo` (optional) - The Ecto repository module for database interaction. If not provided, it is inferred from the `:app` option using the default naming convention (e.g., `MyApp.Repo`).\n  - `:image` (optional) - Specifies the Docker image for the Mysql container. This must be a legitimate Mysql image, with the image name beginning with \"mysql\". If omitted, the default is \"mysql:8\".\n  - `:user` (optional) - Sets the username for the Mysql instance (defaults to \"test\").\n  - `:password` (optional) - Determines the password for the Mysql user (defaults to \"test\").\n  - `:database` (optional) - Specifies the name of the database to be created within the Mysql instance. If not provided, the default behavior is to create a database with the name derived from the application's atom, appended with \"_test\".\n  - `:migrations_path` (optional) - Indicates the path to the migrations folder (defaults to \"priv/repo/migrations\").\n  - `:persistent_volume_name` (optional, EXPERIMENTAL) - Sets a named volume for the data in the database. This is an experimental option, and changes in database container image or other things that could invalidate the data, would make the container not start properly.\n  - `:check_image` (optional) - Defines a custom regular expression that is used to validate the Docker image.","ref":"Testcontainers.Ecto.html#mysql_container/1-parameters","title":"Parameters - Testcontainers.Ecto.mysql_container/1","type":"function"},{"doc":"It's important to note that the Mysql database initiated by this function will remain operational for the duration of the test process and is not explicitly shut down by the function. The database and its corresponding data are ephemeral, lasting only for the scope of the test session.\n\nAfter the tests conclude, Testcontainers will clean up by removing the database container, ensuring no residual data persists. This approach helps maintain a clean testing environment and prevents any unintended side effects on subsequent tests due to data leftovers.\n\nUsers should not rely on any manual teardown or cleanup for the database, as Testcontainers handles this aspect automatically, providing isolated, repeatable test runs.","ref":"Testcontainers.Ecto.html#mysql_container/1-database-lifecycle-in-testing","title":"Database Lifecycle in Testing - Testcontainers.Ecto.mysql_container/1","type":"function"},{"doc":"# First, you must change the Ecto adapter from Postgres to MyXQL\n\n    defmodule MyApp.Repo do\n      use Ecto.Repo,\n        otp_app: :my_app,\n        adapter: Ecto.Adapters.MyXQL # <- should look like this\n    end\n\n    # Then, in your application.ex file in your Phoenix project:\n\n    import Testcontainers.Ecto\n\n    @impl true\n    def start(_type, _args) do\n      mysql_container(\n        app: :my_app,\n        user: \"postgres\", # consider changing this to something else here and in config/test.exs\n        password: \"postgres\" # consider changing this to something else here and in config/test.exs\n      )\n\n      # .. other setup code\n    end\n\n    # Lastly, in mix.exs, modify the aliases to remove default Ecto setup tasks from the test alias,\n    # as they might interfere with the container-based database setup:\n\n    def aliases do\n      [\n        # ... other aliases\n\n        # Ensure the following line is NOT present, as it would conflict with the container setup:\n        # test: [\"ecto.create --quiet\", \"ecto.migrate --quiet\", \"test\"],\n      ]\n    end\n\n    # in your config/test.exs, if you want to keep appending the MIX_TEST_PARTITION env variable to the database name,\n    # you must set the database option in mysql_container function to the same value\n\n    config :my_app, MyApp.Repo,\n      username: \"postgres\", # <- consider changing this when using mysql\n      password: \"postgres\", # <- consider changing this when using mysql\n      hostname: \"localhost\",\n      database: \"my_app_test#{System.get_env(\"MIX_TEST_PARTITION\")}\", # set this also in mysql_container function database option, or remove the appending\n      pool: Ecto.Adapters.SQL.Sandbox,\n      pool_size: 10\n\n    # for example, to set the database name to the one above, in application.ex:\n\n    @impl true\n    def start(_type, _args) do\n      mysql_container(\n        app: :my_app,\n        user: \"postgres\", # <- consider changing this when using mysql\n        password: \"postgres\", # <- consider changing this when using mysql\n        database: \"my_app_test#{System.get_env(\"MIX_TEST_PARTITION\")}\"\n      )\n\n      # .. other setup code\n    end","ref":"Testcontainers.Ecto.html#mysql_container/1-examples","title":"Examples - Testcontainers.Ecto.mysql_container/1","type":"function"},{"doc":"- `:ok` if the container is initiated successfully.\n- `{:error, reason}` if there is a failure in initiating the container, with `reason` explaining the cause of the failure.","ref":"Testcontainers.Ecto.html#mysql_container/1-returns","title":"Returns - Testcontainers.Ecto.mysql_container/1","type":"function"},{"doc":"- Raises `ArgumentError` if the application is missing, not an atom, or not loaded.\n- Raises `ArgumentError` if the repo is defined and not an atom\n- Raises `ArgumentError` if the specified Docker image is not a valid MySql image.","ref":"Testcontainers.Ecto.html#mysql_container/1-errors","title":"Errors - Testcontainers.Ecto.mysql_container/1","type":"function"},{"doc":"This utility is intended for testing environments requiring a genuine database instance. It is not suitable for production use. It mandates a valid Mysql Docker image to maintain consistent and reliable testing conditions.","ref":"Testcontainers.Ecto.html#mysql_container/1-note","title":"Note - Testcontainers.Ecto.mysql_container/1","type":"function"},{"doc":"Initiates a new Postgres instance, executes migrations, and prepares a suitable database environment, specifically tailored for testing scenarios.","ref":"Testcontainers.Ecto.html#postgres_container/1","title":"Testcontainers.Ecto.postgres_container/1","type":"function"},{"doc":"- `options`: Configurations for the Postgres container, provided as a keyword list. The only required option is `:app`. Other options include:\n  - `:app` - The current application's atom, necessary for building paths and other application-specific logic. This is a required parameter.\n  - `:repo` (optional) - The Ecto repository module for database interaction. If not provided, it is inferred from the `:app` option using the default naming convention (e.g., `MyApp.Repo`).\n  - `:image` (optional) - Specifies the Docker image for the Postgres container. This must be a legitimate Postgres image, with the image name beginning with \"postgres\". If omitted, the default is \"postgres:15\".\n  - `:user` (optional) - Sets the username for the Postgres instance (defaults to \"postgres\").\n  - `:password` (optional) - Determines the password for the Postgres user (defaults to \"postgres\").\n  - `:database` (optional) - Specifies the name of the database to be created within the Postgres instance. If not provided, the default behavior is to create a database with the name derived from the application's atom, appended with \"_test\".\n  - `:migrations_path` (optional) - Indicates the path to the migrations folder (defaults to \"priv/repo/migrations\").\n  - `:persistent_volume_name` (optional, EXPERIMENTAL) - Sets a named volume for the data in the database. This is an experimental option, and changes in database container image or other things that could invalidate the data, would make the container not start properly.\n  - `:check_image` (optional) - Defines a custom regular expression that is used to validate the Docker image.","ref":"Testcontainers.Ecto.html#postgres_container/1-parameters","title":"Parameters - Testcontainers.Ecto.postgres_container/1","type":"function"},{"doc":"It's important to note that the Postgres database initiated by this function will remain operational for the duration of the test process and is not explicitly shut down by the test. The database and its corresponding data are ephemeral, lasting only for the scope of the test session.\n\nAfter the tests conclude, Testcontainers will clean up by removing the database container, ensuring no residual data persists. This approach helps maintain a clean testing environment and prevents any unintended side effects on subsequent tests due to data leftovers.\n\nUsers should not rely on any manual teardown or cleanup for the database, as Testcontainers handles this aspect automatically, providing isolated, repeatable test runs.","ref":"Testcontainers.Ecto.html#postgres_container/1-database-lifecycle-in-testing","title":"Database Lifecycle in Testing - Testcontainers.Ecto.postgres_container/1","type":"function"},{"doc":"# In your application.ex file in your Phoenix project:\n\n    import Testcontainers.Ecto\n\n    @impl true\n    def start(_type, _args) do\n      postgres_container(\n        app: :my_app,\n        user: \"postgres\",\n        password: \"postgres\"\n      )\n\n      # .. other setup code\n    end\n\n    # In mix.exs, modify the aliases to remove default Ecto setup tasks from the test alias,\n    # as they might interfere with the container-based database setup:\n\n    def aliases do\n      [\n        # ... other aliases\n\n        # Ensure the following line is NOT present, as it would conflict with the container setup:\n        # test: [\"ecto.create --quiet\", \"ecto.migrate --quiet\", \"test\"],\n      ]\n    end\n\n    # in your config/test.exs, if you want to keep appending the MIX_TEST_PARTITION env variable to the database name,\n    # you must set the database option in postgres_container function to the same value\n\n    config :my_app, MyApp.Repo,\n      username: \"postgres\",\n      password: \"postgres\",\n      hostname: \"localhost\",\n      database: \"my_app_test#{System.get_env(\"MIX_TEST_PARTITION\")}\", # set this also in postgres_container function database option, or remove the appending\n      pool: Ecto.Adapters.SQL.Sandbox,\n      pool_size: 10\n\n    # for example, to set the database name to the one above, in application.ex:\n\n    @impl true\n    def start(_type, _args) do\n      postgres_container(\n        app: :my_app,\n        user: \"postgres\",\n        password: \"postgres\",\n        database: \"my_app_test#{System.get_env(\"MIX_TEST_PARTITION\")}\"\n      )\n\n      # .. other setup code\n    end","ref":"Testcontainers.Ecto.html#postgres_container/1-examples","title":"Examples - Testcontainers.Ecto.postgres_container/1","type":"function"},{"doc":"- `:ok` if the container is initiated successfully.\n- `{:error, reason}` if there is a failure in initiating the container, with `reason` explaining the cause of the failure.","ref":"Testcontainers.Ecto.html#postgres_container/1-returns","title":"Returns - Testcontainers.Ecto.postgres_container/1","type":"function"},{"doc":"- Raises `ArgumentError` if the application is missing, not an atom, or not loaded.\n- Raises `ArgumentError` if the repo is defined and not an atom\n- Raises `ArgumentError` if the specified Docker image is not a valid Postgres image.","ref":"Testcontainers.Ecto.html#postgres_container/1-errors","title":"Errors - Testcontainers.Ecto.postgres_container/1","type":"function"},{"doc":"This utility is intended for testing environments requiring a genuine database instance. It is not suitable for production use. It mandates a valid Postgres Docker image to maintain consistent and reliable testing conditions.","ref":"Testcontainers.Ecto.html#postgres_container/1-note","title":"Note - Testcontainers.Ecto.postgres_container/1","type":"function"},{"doc":"Provides functionality for creating and managing EMQX container configurations.","ref":"Testcontainers.EmqxContainer.html","title":"Testcontainers.EmqxContainer","type":"module"},{"doc":"Retrieves the default Docker image for the Emqx container.","ref":"Testcontainers.EmqxContainer.html#default_image/0","title":"Testcontainers.EmqxContainer.default_image/0","type":"function"},{"doc":"Returns the address on the _host machine_ where the Emqx container is listening.","ref":"Testcontainers.EmqxContainer.html#host/0","title":"Testcontainers.EmqxContainer.host/0","type":"function"},{"doc":"Returns the port on the _host machine_ where the Emqx container is listening.","ref":"Testcontainers.EmqxContainer.html#mqtt_port/1","title":"Testcontainers.EmqxContainer.mqtt_port/1","type":"function"},{"doc":"Creates a new `EmqxContainer` struct with default configurations.","ref":"Testcontainers.EmqxContainer.html#new/0","title":"Testcontainers.EmqxContainer.new/0","type":"function"},{"doc":"Set the regular expression to check the image validity.","ref":"Testcontainers.EmqxContainer.html#with_check_image/2","title":"Testcontainers.EmqxContainer.with_check_image/2","type":"function"},{"doc":"Overrides the default image used for the Emqx container.","ref":"Testcontainers.EmqxContainer.html#with_image/2","title":"Testcontainers.EmqxContainer.with_image/2","type":"function"},{"doc":"iex> config = EmqxContainer.new()\n    iex> new_config = EmqxContainer.with_image(config, \"emqx:xyz\")\n    iex> new_config.image\n    \"emqx:xyz\"","ref":"Testcontainers.EmqxContainer.html#with_image/2-examples","title":"Examples - Testcontainers.EmqxContainer.with_image/2","type":"function"},{"doc":"","ref":"Testcontainers.EmqxContainer.html#with_ports/6","title":"Testcontainers.EmqxContainer.with_ports/6","type":"function"},{"doc":"Set the reuse flag to reuse the container if it is already running.","ref":"Testcontainers.EmqxContainer.html#with_reuse/2","title":"Testcontainers.EmqxContainer.with_reuse/2","type":"function"},{"doc":"Convenient macros to run containers within ExUnit tests.","ref":"Testcontainers.ExUnit.html","title":"Testcontainers.ExUnit","type":"module"},{"doc":"Creates and manages the lifecycle of a container within ExUnit tests.\n\nWhen the `:shared` option is set to `true`, the container is created once for all tests in the module. It initializes the container before any test is run and keeps it running across multiple tests. This is useful for scenarios where the cost of setting up and tearing down the container is high, or the tests are read-only and won't change the container's state.\n\nWhen the `:shared` option is omitted or set to `false`, a new container is created for each individual test, ensuring a clean state for each test case. The container is removed after each test finishes.","ref":"Testcontainers.ExUnit.html#container/3","title":"Testcontainers.ExUnit.container/3","type":"macro"},{"doc":"* `name`: The key that should be used to reference the container in test cases.\n  * `config`: Configuration necessary for initializing the container.\n  * `options`: Optional keyword list. Supports the following options:\n    * `:shared` - If set to `true`, the container is shared across all tests in the module. If `false` or omitted, a new container is used for each test.","ref":"Testcontainers.ExUnit.html#container/3-parameters","title":"Parameters - Testcontainers.ExUnit.container/3","type":"macro"},{"doc":"To create a new container for each test:\n\n    defmodule MyTest do\n      use ExUnit.Case\n\n      alias Testcontainers.Container\n\n      container :my_container, %Container{image: \"my_image\"}\n      # ...\n    end\n\nTo share a container across all tests in the module:\n\n    defmodule MySharedTest do\n      use ExUnit.Case\n\n      alias Testcontainers.Container\n\n      container :my_shared_container, %Container{image: \"my_shared_image\"}, shared: true\n      # ...\n    end","ref":"Testcontainers.ExUnit.html#container/3-examples","title":"Examples - Testcontainers.ExUnit.container/3","type":"macro"},{"doc":"* The macro sets up the necessary ExUnit callbacks to manage the container's lifecycle.\n  * It ensures the `Connection` and `Reaper` are started before initializing a container.\n  * In the case of shared containers, be mindful that tests can affect the container's state, potentially leading to interdependencies between tests.","ref":"Testcontainers.ExUnit.html#container/3-notes","title":"Notes - Testcontainers.ExUnit.container/3","type":"macro"},{"doc":"Provides functionality for creating and managing Kafka container configurations.","ref":"Testcontainers.KafkaContainer.html","title":"Testcontainers.KafkaContainer","type":"module"},{"doc":"Creates a new `KafkaContainer` struct with default configurations.","ref":"Testcontainers.KafkaContainer.html#new/0","title":"Testcontainers.KafkaContainer.new/0","type":"function"},{"doc":"Overrides the default broker id used for the Kafka container.","ref":"Testcontainers.KafkaContainer.html#with_broker_id/2","title":"Testcontainers.KafkaContainer.with_broker_id/2","type":"function"},{"doc":"Overrides the default kafka port used for the Kafka container.","ref":"Testcontainers.KafkaContainer.html#with_broker_port/2","title":"Testcontainers.KafkaContainer.with_broker_port/2","type":"function"},{"doc":"Overrides the default zookeeper host used for the Kafka container.\nAvailable only when consensus_strategy is kraft","ref":"Testcontainers.KafkaContainer.html#with_cluster_id/2","title":"Testcontainers.KafkaContainer.with_cluster_id/2","type":"function"},{"doc":"Overrides the default consensus strategy used for the Kafka container.","ref":"Testcontainers.KafkaContainer.html#with_consensus_strategy/2","title":"Testcontainers.KafkaContainer.with_consensus_strategy/2","type":"function"},{"doc":"Overrides the default image used for the Kafka container.\nRight now we support only confluentinc images.","ref":"Testcontainers.KafkaContainer.html#with_image/2","title":"Testcontainers.KafkaContainer.with_image/2","type":"function"},{"doc":"Overrides the default kafka port used for the Kafka container.","ref":"Testcontainers.KafkaContainer.html#with_kafka_port/2","title":"Testcontainers.KafkaContainer.with_kafka_port/2","type":"function"},{"doc":"Set the reuse flag to reuse the container if it is already running.","ref":"Testcontainers.KafkaContainer.html#with_reuse/2","title":"Testcontainers.KafkaContainer.with_reuse/2","type":"function"},{"doc":"Overrides the default topic","ref":"Testcontainers.KafkaContainer.html#with_topic_partitions/2","title":"Testcontainers.KafkaContainer.with_topic_partitions/2","type":"function"},{"doc":"Overrides the default wait timeout used for the Kafka container.","ref":"Testcontainers.KafkaContainer.html#with_wait_timeout/2","title":"Testcontainers.KafkaContainer.with_wait_timeout/2","type":"function"},{"doc":"Overrides the default zookeeper host used for the Kafka container.\nAvailable only when consensus_strategy is external","ref":"Testcontainers.KafkaContainer.html#with_zookeeper_host/2","title":"Testcontainers.KafkaContainer.with_zookeeper_host/2","type":"function"},{"doc":"Overrides the default zookeeper port used for the Kafka container.","ref":"Testcontainers.KafkaContainer.html#with_zookeeper_port/2","title":"Testcontainers.KafkaContainer.with_zookeeper_port/2","type":"function"},{"doc":"Considers the container as ready as soon as a specific log message is detected in the container's log stream.","ref":"Testcontainers.LogWaitStrategy.html","title":"Testcontainers.LogWaitStrategy","type":"module"},{"doc":"Creates a new LogWaitStrategy.\nThis strategy waits until a specific log message, matching the provided regex, appears in the container's log.","ref":"Testcontainers.LogWaitStrategy.html#new/3","title":"Testcontainers.LogWaitStrategy.new/3","type":"function"},{"doc":"Defines an abstraction on top of Elixir.Logger","ref":"Testcontainers.Logger.html","title":"Testcontainers.Logger","type":"module"},{"doc":"","ref":"Testcontainers.Logger.html#log/1","title":"Testcontainers.Logger.log/1","type":"function"},{"doc":"Provides functionality for creating and managing Minio container configurations.","ref":"Testcontainers.MinioContainer.html","title":"Testcontainers.MinioContainer","type":"module"},{"doc":"Generates the connection options for accessing the Minio service running within the container.\nCompatible with what ex_aws expects in `ExAws.request(options)`","ref":"Testcontainers.MinioContainer.html#connection_opts/1","title":"Testcontainers.MinioContainer.connection_opts/1","type":"function"},{"doc":"Generates the connection URL for accessing the Minio service running within the container.","ref":"Testcontainers.MinioContainer.html#connection_url/1","title":"Testcontainers.MinioContainer.connection_url/1","type":"function"},{"doc":"","ref":"Testcontainers.MinioContainer.html#default_s3_port/0","title":"Testcontainers.MinioContainer.default_s3_port/0","type":"function"},{"doc":"","ref":"Testcontainers.MinioContainer.html#default_ui_port/0","title":"Testcontainers.MinioContainer.default_ui_port/0","type":"function"},{"doc":"","ref":"Testcontainers.MinioContainer.html#get_password/0","title":"Testcontainers.MinioContainer.get_password/0","type":"function"},{"doc":"","ref":"Testcontainers.MinioContainer.html#get_username/0","title":"Testcontainers.MinioContainer.get_username/0","type":"function"},{"doc":"","ref":"Testcontainers.MinioContainer.html#new/0","title":"Testcontainers.MinioContainer.new/0","type":"function"},{"doc":"Retrieves the port mapped by the Docker host for the Minio container.","ref":"Testcontainers.MinioContainer.html#port/1","title":"Testcontainers.MinioContainer.port/1","type":"function"},{"doc":"Set the reuse flag to reuse the container if it is already running.","ref":"Testcontainers.MinioContainer.html#with_reuse/2","title":"Testcontainers.MinioContainer.with_reuse/2","type":"function"},{"doc":"Provides functionality for creating and managing MySQL container configurations.","ref":"Testcontainers.MySqlContainer.html","title":"Testcontainers.MySqlContainer","type":"module"},{"doc":"Returns the connection parameters to connect to the database from the _host machine_.","ref":"Testcontainers.MySqlContainer.html#connection_parameters/1","title":"Testcontainers.MySqlContainer.connection_parameters/1","type":"function"},{"doc":"Retrieves the default Docker image for the MySQL container.","ref":"Testcontainers.MySqlContainer.html#default_image/0","title":"Testcontainers.MySqlContainer.default_image/0","type":"function"},{"doc":"Retrieves the default Docker image including tag for the MySQL container.","ref":"Testcontainers.MySqlContainer.html#default_image_with_tag/0","title":"Testcontainers.MySqlContainer.default_image_with_tag/0","type":"function"},{"doc":"Retrieves the default exposed port for the MySQL container.","ref":"Testcontainers.MySqlContainer.html#default_port/0","title":"Testcontainers.MySqlContainer.default_port/0","type":"function"},{"doc":"Creates a new `MySqlContainer` struct with default configurations.","ref":"Testcontainers.MySqlContainer.html#new/0","title":"Testcontainers.MySqlContainer.new/0","type":"function"},{"doc":"Returns the port on the _host machine_ where the MySql container is listening.","ref":"Testcontainers.MySqlContainer.html#port/1","title":"Testcontainers.MySqlContainer.port/1","type":"function"},{"doc":"Set the regular expression to check the image validity.","ref":"Testcontainers.MySqlContainer.html#with_check_image/2","title":"Testcontainers.MySqlContainer.with_check_image/2","type":"function"},{"doc":"Overrides the default database used for the MySQL container.","ref":"Testcontainers.MySqlContainer.html#with_database/2","title":"Testcontainers.MySqlContainer.with_database/2","type":"function"},{"doc":"iex> config = MySqlContainer.new()\n    iex> new_config = MySqlContainer.with_database(config, \"another-database\")\n    iex> new_config.database\n    \"another-database\"","ref":"Testcontainers.MySqlContainer.html#with_database/2-examples","title":"Examples - Testcontainers.MySqlContainer.with_database/2","type":"function"},{"doc":"Overrides the default image used for the MySQL container.","ref":"Testcontainers.MySqlContainer.html#with_image/2","title":"Testcontainers.MySqlContainer.with_image/2","type":"function"},{"doc":"iex> config = MySqlContainer.new()\n    iex> new_config = MySqlContainer.with_image(config, \"mysql:4\")\n    iex> new_config.image\n    \"mysql:4\"","ref":"Testcontainers.MySqlContainer.html#with_image/2-examples","title":"Examples - Testcontainers.MySqlContainer.with_image/2","type":"function"},{"doc":"Overrides the default password used for the MySQL container.","ref":"Testcontainers.MySqlContainer.html#with_password/2","title":"Testcontainers.MySqlContainer.with_password/2","type":"function"},{"doc":"iex> config = MySqlContainer.new()\n    iex> new_config = MySqlContainer.with_password(config, \"another-password\")\n    iex> new_config.password\n    \"another-password\"","ref":"Testcontainers.MySqlContainer.html#with_password/2-examples","title":"Examples - Testcontainers.MySqlContainer.with_password/2","type":"function"},{"doc":"","ref":"Testcontainers.MySqlContainer.html#with_persistent_volume/2","title":"Testcontainers.MySqlContainer.with_persistent_volume/2","type":"function"},{"doc":"Overrides the default port used for the MySQL container.\n\nNote: this will not change what port the docker container is listening to internally.","ref":"Testcontainers.MySqlContainer.html#with_port/2","title":"Testcontainers.MySqlContainer.with_port/2","type":"function"},{"doc":"iex> config = MySqlContainer.new()\n    iex> new_config = MySqlContainer.with_port(config, 3307)\n    iex> new_config.port\n    3307","ref":"Testcontainers.MySqlContainer.html#with_port/2-examples","title":"Examples - Testcontainers.MySqlContainer.with_port/2","type":"function"},{"doc":"Set the reuse flag to reuse the container if it is already running.","ref":"Testcontainers.MySqlContainer.html#with_reuse/2","title":"Testcontainers.MySqlContainer.with_reuse/2","type":"function"},{"doc":"Overrides the default user used for the MySQL container.","ref":"Testcontainers.MySqlContainer.html#with_user/2","title":"Testcontainers.MySqlContainer.with_user/2","type":"function"},{"doc":"iex> config = MySqlContainer.new()\n    iex> new_config = MySqlContainer.with_user(config, \"another-user\")\n    iex> new_config.user\n    \"another-user\"","ref":"Testcontainers.MySqlContainer.html#with_user/2-examples","title":"Examples - Testcontainers.MySqlContainer.with_user/2","type":"function"},{"doc":"Overrides the default wait timeout used for the MySQL container.\n\nNote: this timeout will be used for each individual wait strategy.","ref":"Testcontainers.MySqlContainer.html#with_wait_timeout/2","title":"Testcontainers.MySqlContainer.with_wait_timeout/2","type":"function"},{"doc":"iex> config = MySqlContainer.new()\n    iex> new_config = MySqlContainer.with_wait_timeout(config, 8000)\n    iex> new_config.wait_timeout\n    8000","ref":"Testcontainers.MySqlContainer.html#with_wait_timeout/2-examples","title":"Examples - Testcontainers.MySqlContainer.with_wait_timeout/2","type":"function"},{"doc":"Considers the container as ready when it successfully accepts connections on the specified port.","ref":"Testcontainers.PortWaitStrategy.html","title":"Testcontainers.PortWaitStrategy","type":"module"},{"doc":"Creates a new PortWaitStrategy to wait until a specified port is open and accepting connections.","ref":"Testcontainers.PortWaitStrategy.html#new/4","title":"Testcontainers.PortWaitStrategy.new/4","type":"function"},{"doc":"Provides functionality for creating and managing Postgres container configurations.","ref":"Testcontainers.PostgresContainer.html","title":"Testcontainers.PostgresContainer","type":"module"},{"doc":"Returns the connection parameters to connect to the database from the _host machine_.","ref":"Testcontainers.PostgresContainer.html#connection_parameters/1","title":"Testcontainers.PostgresContainer.connection_parameters/1","type":"function"},{"doc":"Retrieves the default Docker image for the Postgres container.","ref":"Testcontainers.PostgresContainer.html#default_image/0","title":"Testcontainers.PostgresContainer.default_image/0","type":"function"},{"doc":"Retrieves the default Docker image including tag for the Postgres container.","ref":"Testcontainers.PostgresContainer.html#default_image_with_tag/0","title":"Testcontainers.PostgresContainer.default_image_with_tag/0","type":"function"},{"doc":"Retrieves the default exposed port for the Postgres container.","ref":"Testcontainers.PostgresContainer.html#default_port/0","title":"Testcontainers.PostgresContainer.default_port/0","type":"function"},{"doc":"Creates a new `PostgresContainer` struct with default configurations.","ref":"Testcontainers.PostgresContainer.html#new/0","title":"Testcontainers.PostgresContainer.new/0","type":"function"},{"doc":"Returns the port on the _host machine_ where the Postgres container is listening.","ref":"Testcontainers.PostgresContainer.html#port/1","title":"Testcontainers.PostgresContainer.port/1","type":"function"},{"doc":"Set the regular expression to check the image validity.","ref":"Testcontainers.PostgresContainer.html#with_check_image/2","title":"Testcontainers.PostgresContainer.with_check_image/2","type":"function"},{"doc":"Overrides the default database used for the Postgres container.","ref":"Testcontainers.PostgresContainer.html#with_database/2","title":"Testcontainers.PostgresContainer.with_database/2","type":"function"},{"doc":"iex> config = PostgresContainer.new()\n    iex> new_config = PostgresContainer.with_database(config, \"another-database\")\n    iex> new_config.database\n    \"another-database\"","ref":"Testcontainers.PostgresContainer.html#with_database/2-examples","title":"Examples - Testcontainers.PostgresContainer.with_database/2","type":"function"},{"doc":"Overrides the default image used for the Postgres container.","ref":"Testcontainers.PostgresContainer.html#with_image/2","title":"Testcontainers.PostgresContainer.with_image/2","type":"function"},{"doc":"iex> config = PostgresContainer.new()\n    iex> new_config = PostgresContainer.with_image(config, \"postgres:12\")\n    iex> new_config.image\n    \"postgres:12\"","ref":"Testcontainers.PostgresContainer.html#with_image/2-examples","title":"Examples - Testcontainers.PostgresContainer.with_image/2","type":"function"},{"doc":"Overrides the default password used for the Postgres container.","ref":"Testcontainers.PostgresContainer.html#with_password/2","title":"Testcontainers.PostgresContainer.with_password/2","type":"function"},{"doc":"iex> config = PostgresContainer.new()\n    iex> new_config = PostgresContainer.with_password(config, \"another-password\")\n    iex> new_config.password\n    \"another-password\"","ref":"Testcontainers.PostgresContainer.html#with_password/2-examples","title":"Examples - Testcontainers.PostgresContainer.with_password/2","type":"function"},{"doc":"","ref":"Testcontainers.PostgresContainer.html#with_persistent_volume/2","title":"Testcontainers.PostgresContainer.with_persistent_volume/2","type":"function"},{"doc":"Overrides the default port used for the Postgres container.\n\nNote: this will not change what port the docker container is listening to internally.","ref":"Testcontainers.PostgresContainer.html#with_port/2","title":"Testcontainers.PostgresContainer.with_port/2","type":"function"},{"doc":"iex> config = PostgresContainer.new()\n    iex> new_config = PostgresContainer.with_port(config, 2345)\n    iex> new_config.port\n    2345","ref":"Testcontainers.PostgresContainer.html#with_port/2-examples","title":"Examples - Testcontainers.PostgresContainer.with_port/2","type":"function"},{"doc":"Set the reuse flag to reuse the container if it is already running.","ref":"Testcontainers.PostgresContainer.html#with_reuse/2","title":"Testcontainers.PostgresContainer.with_reuse/2","type":"function"},{"doc":"Overrides the default user used for the Postgres container.","ref":"Testcontainers.PostgresContainer.html#with_user/2","title":"Testcontainers.PostgresContainer.with_user/2","type":"function"},{"doc":"iex> config = PostgresContainer.new()\n    iex> new_config = PostgresContainer.with_user(config, \"another-user\")\n    iex> new_config.user\n    \"another-user\"","ref":"Testcontainers.PostgresContainer.html#with_user/2-examples","title":"Examples - Testcontainers.PostgresContainer.with_user/2","type":"function"},{"doc":"Overrides the default wait timeout used for the Postgres container.\n\nNote: this timeout will be used for each individual wait strategy.","ref":"Testcontainers.PostgresContainer.html#with_wait_timeout/2","title":"Testcontainers.PostgresContainer.with_wait_timeout/2","type":"function"},{"doc":"iex> config = PostgresContainer.new()\n    iex> new_config = PostgresContainer.with_wait_timeout(config, 8000)\n    iex> new_config.wait_timeout\n    8000","ref":"Testcontainers.PostgresContainer.html#with_wait_timeout/2-examples","title":"Examples - Testcontainers.PostgresContainer.with_wait_timeout/2","type":"function"},{"doc":"Provides functionality for creating and managing RabbitMQ container configurations.\n\nNOTE: The default starting command is `chmod 400 /var/lib/rabbitmq/.erlang.cookie; rabbitmq-server`.\n`chmod 400 /var/lib/rabbitmq/.erlang.cookie` is necessary for the waiting strategy, which calls the command `rabbitmq-diagnostics check_running`; otherwise CLI tools cannot communicate with the RabbitMQ node.","ref":"Testcontainers.RabbitMQContainer.html","title":"Testcontainers.RabbitMQContainer","type":"module"},{"doc":"Returns the connection parameters to connect to RabbitMQ from the _host machine_.","ref":"Testcontainers.RabbitMQContainer.html#connection_parameters/1","title":"Testcontainers.RabbitMQContainer.connection_parameters/1","type":"function"},{"doc":"- `container`: The active RabbitMQ container instance in the form of a %Container{} struct.","ref":"Testcontainers.RabbitMQContainer.html#connection_parameters/1-parameters","title":"Parameters - Testcontainers.RabbitMQContainer.connection_parameters/1","type":"function"},{"doc":"iex> RabbitMQContainer.connection_parameters(container)\n    [\n      host: \"localhost\",\n      port: 32768,\n      username: \"guest\",\n      password: \"guest\",\n      vhost: \"/\"\n    ]","ref":"Testcontainers.RabbitMQContainer.html#connection_parameters/1-examples","title":"Examples - Testcontainers.RabbitMQContainer.connection_parameters/1","type":"function"},{"doc":"Generates the connection URL for accessing the RabbitMQ service running within the container.\n\nThis URI is based on the AMQP 0-9-1, and has the following scheme:\namqp://username:password@host:port/vhost","ref":"Testcontainers.RabbitMQContainer.html#connection_url/1","title":"Testcontainers.RabbitMQContainer.connection_url/1","type":"function"},{"doc":"- `container`: The active RabbitMQ container instance in the form of a %Container{} struct.","ref":"Testcontainers.RabbitMQContainer.html#connection_url/1-parameters","title":"Parameters - Testcontainers.RabbitMQContainer.connection_url/1","type":"function"},{"doc":"iex> RabbitMQContainer.connection_url(container)\n    \"amqp://guest:guest@localhost:32768\"\n    iex> RabbitMQContainer.connection_url(container_with_vhost)\n    \"amqp://guest:guest@localhost:32768/vhost\"","ref":"Testcontainers.RabbitMQContainer.html#connection_url/1-examples","title":"Examples - Testcontainers.RabbitMQContainer.connection_url/1","type":"function"},{"doc":"Retrieves the default Docker image for the RabbitMQ container","ref":"Testcontainers.RabbitMQContainer.html#default_image/0","title":"Testcontainers.RabbitMQContainer.default_image/0","type":"function"},{"doc":"Retrieves the default Docker image including tag for the RabbitMQ container","ref":"Testcontainers.RabbitMQContainer.html#default_image_with_tag/0","title":"Testcontainers.RabbitMQContainer.default_image_with_tag/0","type":"function"},{"doc":"Retrieves the default exposed port for the RabbitMQ container","ref":"Testcontainers.RabbitMQContainer.html#default_port/0","title":"Testcontainers.RabbitMQContainer.default_port/0","type":"function"},{"doc":"Creates a new `RabbitMQContainer` struct with default configurations.","ref":"Testcontainers.RabbitMQContainer.html#new/0","title":"Testcontainers.RabbitMQContainer.new/0","type":"function"},{"doc":"Returns the port on the _host machine_ where the RabbitMQ container is listening.","ref":"Testcontainers.RabbitMQContainer.html#port/1","title":"Testcontainers.RabbitMQContainer.port/1","type":"function"},{"doc":"Set the regular expression to check the image validity.","ref":"Testcontainers.RabbitMQContainer.html#with_check_image/2","title":"Testcontainers.RabbitMQContainer.with_check_image/2","type":"function"},{"doc":"Overrides the default command used for the RabbitMQ container.","ref":"Testcontainers.RabbitMQContainer.html#with_cmd/2","title":"Testcontainers.RabbitMQContainer.with_cmd/2","type":"function"},{"doc":"iex> config = RabbitMQContainer.new() |> RabbitMQContainer.with_cmd([\"sh\", \"-c\", \"rabbitmq-server\"])\n  iex> config.cmd\n  [\"sh\", \"-c\", \"rabbitmq-server\"]","ref":"Testcontainers.RabbitMQContainer.html#with_cmd/2-examples","title":"Examples - Testcontainers.RabbitMQContainer.with_cmd/2","type":"function"},{"doc":"","ref":"Testcontainers.RabbitMQContainer.html#with_force_reuse/1","title":"Testcontainers.RabbitMQContainer.with_force_reuse/1","type":"function"},{"doc":"Overrides the default image use for the RabbitMQ container.","ref":"Testcontainers.RabbitMQContainer.html#with_image/2","title":"Testcontainers.RabbitMQContainer.with_image/2","type":"function"},{"doc":"iex> config = RabbitMQContainer.new() |> RabbitMQContainer.with_image(\"rabbitmq:xyz\")\n  iex> config.image\n  \"rabbitmq:xyz\"","ref":"Testcontainers.RabbitMQContainer.html#with_image/2-examples","title":"Examples - Testcontainers.RabbitMQContainer.with_image/2","type":"function"},{"doc":"Overrides the default password used for the RabbitMQ container.","ref":"Testcontainers.RabbitMQContainer.html#with_password/2","title":"Testcontainers.RabbitMQContainer.with_password/2","type":"function"},{"doc":"iex> config = RabbitMQContainer.new() |> RabbitMQContainer.with_password(\"rabbitmq\")\n  iex> config.password\n  \"rabbitmq\"","ref":"Testcontainers.RabbitMQContainer.html#with_password/2-examples","title":"Examples - Testcontainers.RabbitMQContainer.with_password/2","type":"function"},{"doc":"Overrides the default port used for the RabbitMQ container.","ref":"Testcontainers.RabbitMQContainer.html#with_port/2","title":"Testcontainers.RabbitMQContainer.with_port/2","type":"function"},{"doc":"iex> config = RabbitMQContainer.new() |> RabbitMQContainer.with_port(1111)\n  iex> config.port\n  1111","ref":"Testcontainers.RabbitMQContainer.html#with_port/2-examples","title":"Examples - Testcontainers.RabbitMQContainer.with_port/2","type":"function"},{"doc":"Set the reuse flag to reuse the container if it is already running.","ref":"Testcontainers.RabbitMQContainer.html#with_reuse/2","title":"Testcontainers.RabbitMQContainer.with_reuse/2","type":"function"},{"doc":"Overrides the default user used for the RabbitMQ container.","ref":"Testcontainers.RabbitMQContainer.html#with_username/2","title":"Testcontainers.RabbitMQContainer.with_username/2","type":"function"},{"doc":"iex> config = RabbitMQContainer.new() |> RabbitMQContainer.with_username(\"rabbitmq\")\n  iex> config.username\n  \"rabbitmq\"","ref":"Testcontainers.RabbitMQContainer.html#with_username/2-examples","title":"Examples - Testcontainers.RabbitMQContainer.with_username/2","type":"function"},{"doc":"Overrides the default virtual host used for the RabbitMQ container.","ref":"Testcontainers.RabbitMQContainer.html#with_virtual_host/2","title":"Testcontainers.RabbitMQContainer.with_virtual_host/2","type":"function"},{"doc":"iex> config = RabbitMQContainer.new() |> RabbitMQContainer.with_virtual_host(\"/\")\n  iex> config.password\n  \"/\"","ref":"Testcontainers.RabbitMQContainer.html#with_virtual_host/2-examples","title":"Examples - Testcontainers.RabbitMQContainer.with_virtual_host/2","type":"function"},{"doc":"Overrides the default wait timeout used for the RabbitMQ container.\n\nNote: this timeout will be used for each individual wait strategy.","ref":"Testcontainers.RabbitMQContainer.html#with_wait_timeout/2","title":"Testcontainers.RabbitMQContainer.with_wait_timeout/2","type":"function"},{"doc":"iex> config = RabbitMQContainer.new() |> RabbitMQContainer.with_wait_timeout(60000)\n  iex> config.wait_timeout\n  60000","ref":"Testcontainers.RabbitMQContainer.html#with_wait_timeout/2-examples","title":"Examples - Testcontainers.RabbitMQContainer.with_wait_timeout/2","type":"function"},{"doc":"Provides functionality for creating and managing Redis container configurations.","ref":"Testcontainers.RedisContainer.html","title":"Testcontainers.RedisContainer","type":"module"},{"doc":"Generates the connection URL for accessing the Redis service running within the container.\n\nThis URL is based on the standard localhost IP and the mapped port for the container.","ref":"Testcontainers.RedisContainer.html#connection_url/1","title":"Testcontainers.RedisContainer.connection_url/1","type":"function"},{"doc":"- `container`: The active Redis container instance in the form of a %Container{} struct.","ref":"Testcontainers.RedisContainer.html#connection_url/1-parameters","title":"Parameters - Testcontainers.RedisContainer.connection_url/1","type":"function"},{"doc":"iex> RedisContainer.connection_url(container)\n    \"http://localhost:32768\" # This value will be different depending on the mapped port.","ref":"Testcontainers.RedisContainer.html#connection_url/1-examples","title":"Examples - Testcontainers.RedisContainer.connection_url/1","type":"function"},{"doc":"Retrieves the default Docker image for the Redis container.","ref":"Testcontainers.RedisContainer.html#default_image/0","title":"Testcontainers.RedisContainer.default_image/0","type":"function"},{"doc":"Creates a new `RedisContainer` struct with default configurations.","ref":"Testcontainers.RedisContainer.html#new/0","title":"Testcontainers.RedisContainer.new/0","type":"function"},{"doc":"Returns the port on the _host machine_ where the Redis container is listening.","ref":"Testcontainers.RedisContainer.html#port/1","title":"Testcontainers.RedisContainer.port/1","type":"function"},{"doc":"Set the regular expression to check the image validity.","ref":"Testcontainers.RedisContainer.html#with_check_image/2","title":"Testcontainers.RedisContainer.with_check_image/2","type":"function"},{"doc":"Overrides the default image used for the Redis container.","ref":"Testcontainers.RedisContainer.html#with_image/2","title":"Testcontainers.RedisContainer.with_image/2","type":"function"},{"doc":"iex> config = RedisContainer.new()\n    iex> new_config = RedisContainer.with_image(config, \"redis:xyz\")\n    iex> new_config.image\n    \"redis:xyz\"","ref":"Testcontainers.RedisContainer.html#with_image/2-examples","title":"Examples - Testcontainers.RedisContainer.with_image/2","type":"function"},{"doc":"Overrides the default port used for the Redis container.\n\nNote: this will not change what port the docker container is listening to internally.","ref":"Testcontainers.RedisContainer.html#with_port/2","title":"Testcontainers.RedisContainer.with_port/2","type":"function"},{"doc":"iex> config = RedisContainer.new()\n    iex> new_config = RedisContainer.with_port(config, 1111)\n    iex> new_config.port\n    1111","ref":"Testcontainers.RedisContainer.html#with_port/2-examples","title":"Examples - Testcontainers.RedisContainer.with_port/2","type":"function"},{"doc":"Set the reuse flag to reuse the container if it is already running.","ref":"Testcontainers.RedisContainer.html#with_reuse/2","title":"Testcontainers.RedisContainer.with_reuse/2","type":"function"},{"doc":"Overrides the default wait timeout used for the Redis container.\n\nNote: this timeout will be used for each individual wait strategy.","ref":"Testcontainers.RedisContainer.html#with_wait_timeout/2","title":"Testcontainers.RedisContainer.with_wait_timeout/2","type":"function"},{"doc":"iex> config = RedisContainer.new()\n    iex> new_config = RedisContainer.with_wait_timeout(config, 8000)\n    iex> new_config.wait_timeout\n    8000","ref":"Testcontainers.RedisContainer.html#with_wait_timeout/2-examples","title":"Examples - Testcontainers.RedisContainer.with_wait_timeout/2","type":"function"},{"doc":"Work in progress. Not stable for use yet. Not yet documented for this very reason.\nCan use https://github.com/stuart/elixir-webdriver for client in tests","ref":"Testcontainers.SeleniumContainer.html","title":"Testcontainers.SeleniumContainer","type":"module"},{"doc":"","ref":"Testcontainers.SeleniumContainer.html#default_image/0","title":"Testcontainers.SeleniumContainer.default_image/0","type":"function"},{"doc":"","ref":"Testcontainers.SeleniumContainer.html#new/0","title":"Testcontainers.SeleniumContainer.new/0","type":"function"},{"doc":"Set the regular expression to check the image validity.","ref":"Testcontainers.SeleniumContainer.html#with_check_image/2","title":"Testcontainers.SeleniumContainer.with_check_image/2","type":"function"},{"doc":"","ref":"Testcontainers.SeleniumContainer.html#with_image/2","title":"Testcontainers.SeleniumContainer.with_image/2","type":"function"},{"doc":"","ref":"Testcontainers.SeleniumContainer.html#with_port1/2","title":"Testcontainers.SeleniumContainer.with_port1/2","type":"function"},{"doc":"","ref":"Testcontainers.SeleniumContainer.html#with_port2/2","title":"Testcontainers.SeleniumContainer.with_port2/2","type":"function"},{"doc":"Set the reuse flag to reuse the container if it is already running.","ref":"Testcontainers.SeleniumContainer.html#with_reuse/2","title":"Testcontainers.SeleniumContainer.with_reuse/2","type":"function"},{"doc":"","ref":"Testcontainers.SeleniumContainer.html#with_wait_timeout/2","title":"Testcontainers.SeleniumContainer.with_wait_timeout/2","type":"function"},{"doc":"","ref":"Testcontainers.Util.Hash.html","title":"Testcontainers.Util.Hash","type":"module"},{"doc":"","ref":"Testcontainers.Util.Hash.html#struct_to_hash/1","title":"Testcontainers.Util.Hash.struct_to_hash/1","type":"function"},{"doc":"","ref":"Testcontainers.Util.ListFromDeepStruct.html","title":"Testcontainers.Util.ListFromDeepStruct","type":"module"},{"doc":"","ref":"Testcontainers.Util.ListFromDeepStruct.html#from_deep_struct/1","title":"Testcontainers.Util.ListFromDeepStruct.from_deep_struct/1","type":"function"},{"doc":"Defines the protocol/interface for the wait strategies in `Testcontainers`","ref":"Testcontainers.WaitStrategy.html","title":"Testcontainers.WaitStrategy","type":"protocol"},{"doc":"","ref":"Testcontainers.WaitStrategy.html#wait_until_container_is_ready/3","title":"Testcontainers.WaitStrategy.wait_until_container_is_ready/3","type":"function"},{"doc":"","ref":"Testcontainers.WaitStrategy.html#t:t/0","title":"Testcontainers.WaitStrategy.t/0","type":"type"}],"producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}